Package: statsapps
Title: Interactive 'Shiny' Apps for Building Statistical Intuition
Version: 0.1.0
Authors@R: 
    person(given = "Vikram B.",
                 family = "Baliga", 
                 role = c("aut", "cre", "cph"),
                 email = "vikram.baliga@ubc.ca",
                 comment = c(ORCID = "0000-0002-9367-8974")
                 )
Description: 
    Provides interactive 'Shiny' applications for building intuition in 
    statistics and data science. The apps run locally and use
    visualization, simulation, and repeated sampling to illustrate topics
    such as probability distributions, permutation tests, analysis of
    variance, linear regression, and sums of squares.
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 8.0.0
Imports: dplyr (>= 1.1.0), ggplot2 (>= 3.4.0), purrr (>= 1.0.0), shiny
        (>= 1.7.0), tibble (>= 3.0.0)
Depends: R (>= 4.1.0)
URL: https://github.com/vbaliga/statsapps,
        https://vbaliga.github.io/statsapps/
BugReports: https://github.com/vbaliga/statsapps/issues
Suggests: testthat (>= 3.0.0)
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2026-07-16 02:11:38 UTC; vikram
Author: Vikram B. Baliga [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0002-9367-8974>)
Maintainer: Vikram B. Baliga <vikram.baliga@ubc.ca>
Repository: CRAN
Date/Publication: 2026-07-23 13:30:02 UTC

# statsapps

<!-- badges: start -->

[![Project Status: Active – The project has reached a stable, usable
state and is being actively
developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)

<!-- badges: end -->

The `statsapps` R package features interactive `Shiny` apps to help you
learn concepts from data science & statistics.

The apps run locally and use visualization, simulation, and repeated
sampling to illustrate topics such as probability distributions,
permutation tests, analysis of variance, linear regression, and sums of
squares.

## Installation

You can install the development version of `statsapps` from [this GitHub
repo](https://github.com/vbaliga/statsapps) with:

``` r
# install.packages("pak")
pak::pak("vbaliga/statsapps")
```

## Example

All apps can be started via functions from `statsapps`. Each app can be
started using a function that begins with `run_`. For example, use
`run_permutation_app()` to start the Shiny app for the Permutation Test.
This will open a new window in your default web browser with the Shiny
app.

``` r
library(statsapps)
run_permutation_app()
```

The example we showcase here is the Permutation Test app, demonstrates
how repeated random reassignment of observations can be used to build a
null distribution for a two-sample permutation test. As with all
`statsapps`, this app is interactive and allows you to see the results
of individual permutations, and how the result of each permutation
incrementally builds the null distribution.

There are several tabs within the main window of the app. The first two
tabs provide an explanation and the original data. The third tab shows
the results of performing permutations. The buttons in the left sidebar
allow you to perform permutations and visualize the outcome of the most
recent permutation.

<p align="center">

<img src="man/figures/perm_app_02.png" width="700"/>

</p>

<hr>

## Contributing and/or raising Issues

Feedback on bugs, improvements, and/or feature requests are all welcome.
Please see the Issues section on GitHub to make a bug fix request or
feature request.

## Citation

TBD

## License

See LICENSE file (MIT)

🐢

#' Launch the one-way ANOVA simulator
#'
#' Opens an interactive Shiny app for exploring how group means, within-group
#' variation, and sample size affect a one-way ANOVA.
#'
#' All data are simulated in R via `rnorm()`.
#'
#' @param ... Optional arguments passed to [shiny::runApp()]. By default,
#' statsapps opens apps in the system default web browser using
#' `launch.browser = TRUE`. Use `launch.browser = FALSE` to disable this
#' behavior.
#'
#' @return `run_anova_app()` opens the Shiny app locally.
#'
#' @importFrom ggplot2 aes geom_boxplot geom_jitter ggplot labs scale_color_manual scale_fill_manual theme_classic ylim
#'
#' @export
#'
#' @examplesIf interactive()
#' run_anova_app()
run_anova_app <- function(...) {
  run_statsapps_app("ANOVA", ...)
}

test_that("app directories exist", {
  app_names <- c(
    "ANOVA",
    "distributions",
    "linear_reg",
    "permutation",
    "sums_squares"
  )

  app_dirs <- system.file("apps", app_names, package = "statsapps")

  expect_true(all(nzchar(app_dirs)))
  expect_true(all(file.exists(app_dirs)))
  expect_true(all(file.exists(file.path(app_dirs, "app.R"))))
})

test_that("launcher functions point to the correct apps", {
  captured <- new.env(parent = emptyenv())
  captured$calls <- character(0)

  local_mocked_bindings(
    run_statsapps_app = function(app_name, ...) {
      captured$calls <- c(captured$calls, app_name)
      invisible(app_name)
    }
  )

  expect_invisible(run_anova_app())
  expect_invisible(run_distributions_app())
  expect_invisible(run_linear_reg_app())
  expect_invisible(run_permutation_app())
  expect_invisible(run_sums_squares_app())

  expect_identical(
    captured$calls,
    c("ANOVA", "distributions", "linear_reg", "permutation", "sums_squares")
  )
})

test_that("run_statsapps_app finds an app directory and calls shiny::runApp", {
  captured <- new.env(parent = emptyenv())
  captured$app_dir <- NULL
  captured$launch_browser <- NULL

  local_mocked_bindings(
    runApp = function(appDir, launch.browser = NULL, ...) {
      captured$app_dir <- appDir
      captured$launch_browser <- launch.browser
      invisible(appDir)
    },
    .package = "shiny"
  )

  expect_invisible(run_statsapps_app("ANOVA"))

  expect_true(nzchar(captured$app_dir))
  expect_true(dir.exists(captured$app_dir))
  expect_true(file.exists(file.path(captured$app_dir, "app.R")))
  expect_true(grepl("ANOVA$", captured$app_dir))
  expect_true(captured$launch_browser)
})

test_that("run_statsapps_app allows browser launch to be disabled", {
  captured <- new.env(parent = emptyenv())
  captured$launch_browser <- NULL

  local_mocked_bindings(
    runApp = function(appDir, launch.browser = NULL, ...) {
      captured$launch_browser <- launch.browser
      invisible(appDir)
    },
    .package = "shiny"
  )

  expect_invisible(run_statsapps_app("ANOVA", launch.browser = FALSE))

  expect_false(captured$launch_browser)
})

test_that("run_statsapps_app respects the statsapps launch browser option", {
  captured <- new.env(parent = emptyenv())
  captured$launch_browser <- NULL

  local_mocked_bindings(
    runApp = function(appDir, launch.browser = NULL, ...) {
      captured$launch_browser <- launch.browser
      invisible(appDir)
    },
    .package = "shiny"
  )

  old_option <- getOption("statsapps.launch.browser")
  on.exit(options(statsapps.launch.browser = old_option), add = TRUE)

  options(statsapps.launch.browser = FALSE)

  expect_invisible(run_statsapps_app("ANOVA"))

  expect_false(captured$launch_browser)
})

test_that("run_statsapps_app errors clearly when an app is missing", {
  expect_error(
    run_statsapps_app("not_an_app"),
    "Could not find the not_an_app app"
  )
})

test_that("launcher functions pass launch.browser through to run_statsapps_app", {
  captured <- new.env(parent = emptyenv())
  captured$args <- list()

  local_mocked_bindings(
    run_statsapps_app = function(app_name, ...) {
      captured$args[[app_name]] <- list(...)
      invisible(app_name)
    }
  )

  expect_invisible(run_anova_app(launch.browser = FALSE))
  expect_invisible(run_distributions_app(launch.browser = FALSE))
  expect_invisible(run_linear_reg_app(launch.browser = FALSE))
  expect_invisible(run_permutation_app(launch.browser = FALSE))
  expect_invisible(run_sums_squares_app(launch.browser = FALSE))

  expect_false(captured$args$ANOVA$launch.browser)
  expect_false(captured$args$distributions$launch.browser)
  expect_false(captured$args$linear_reg$launch.browser)
  expect_false(captured$args$permutation$launch.browser)
  expect_false(captured$args$sums_squares$launch.browser)
})

## PERMUTATION APP


## Original cricket data from Johnson et al. 1999,
## showcased in Example 13.5 of ABD.
cricket_data <- tibble::tibble(
  original_group = c(
    rep("Starved", 11),
    rep("Fed", 13)
  ),
  time_hours = c(
    1.9, 2.1, 3.8, 9.0, 9.6, 13.0, 14.7, 17.9, 21.7, 29.0, 72.3,
    1.5, 1.7, 2.4, 3.6, 5.7, 22.6, 22.8, 39.0, 54.4, 72.1, 73.6,
    79.5, 88.9
  )
) |>
  dplyr::mutate(
    observation_id = dplyr::row_number()
  )

## Fixed observed difference from the real study.
observed_starved_mean <- cricket_data |>
  dplyr::filter(original_group == "Starved") |>
  dplyr::summarize(mean_time = mean(time_hours)) |>
  dplyr::pull(mean_time)

observed_fed_mean <- cricket_data |>
  dplyr::filter(original_group == "Fed") |>
  dplyr::summarize(mean_time = mean(time_hours)) |>
  dplyr::pull(mean_time)

observed_difference <- observed_starved_mean - observed_fed_mean

## Group sizes are preserved in every permutation.
n_starved <- sum(cricket_data$original_group == "Starved")
n_fed <- sum(cricket_data$original_group == "Fed")

permute_once <- function(data) {
  randomized_labels <- sample(
    c(rep("Starved", n_starved), rep("Fed", n_fed)),
    size = nrow(data),
    replace = FALSE
  )

  permuted_data <- data |>
    dplyr::mutate(
      randomized_group = randomized_labels
    )

  randomized_starved_mean <- permuted_data |>
    dplyr::filter(randomized_group == "Starved") |>
    dplyr::summarize(mean_time = mean(time_hours)) |>
    dplyr::pull(mean_time)

  randomized_fed_mean <- permuted_data |>
    dplyr::filter(randomized_group == "Fed") |>
    dplyr::summarize(mean_time = mean(time_hours)) |>
    dplyr::pull(mean_time)

  permuted_difference <- randomized_starved_mean - randomized_fed_mean

  list(
    permuted_data = permuted_data,
    permuted_difference = permuted_difference,
    randomized_starved_mean = randomized_starved_mean,
    randomized_fed_mean = randomized_fed_mean
  )
}

make_slide_table <- function(data, group_name) {
  data |>
    dplyr::filter(randomized_group == group_name) |>
    dplyr::arrange(time_hours) |>
    dplyr::mutate(
      row_class = dplyr::if_else(
        original_group == "Fed",
        "original-fed",
        "original-starved"
      )
    )
}

statsapps_shared_file <- function(...) {
  installed_file <- system.file("app_shared", ..., package = "statsapps")

  if (nzchar(installed_file)) {
    return(installed_file)
  }

  file.path("..", "..", "app_shared", ...)
}

source(statsapps_shared_file("app_settings.R"), local = TRUE)

ui <- shiny::fluidPage(

  shiny::tags$head(
    shiny::includeCSS(statsapps_shared_file("statsapps.css")),
    shiny::tags$style(shiny::HTML("
      body {
        font-size: 16px;
        color: #222222;
        background-color: #ffffff;
      }

      .container-fluid {
        max-width: 1450px;
      }

      .explanation-box {
        background-color: #ffffff;
        border-left: 6px solid #315f96;
        padding: 10px 18px;
        margin-bottom: 18px;
      }

      .well {
        padding: 8px;
      }

      .control-box {
        background-color: #f7f7f7;
        padding: 10px;
        border-radius: 6px;
        margin-bottom: 10px;
      }

      .control-box h4 {
        margin-top: 0;
      }

      .small-note {
        color: #555555;
        font-size: 14px;
      }

      .current-progress-text {
        font-size: 13px;
        line-height: 1.35;
      }

      .current-progress-text p {
        margin-bottom: 8px;
      }

      .current-progress-heading {
        font-size: 16px;
        margin-top: 0;
        margin-bottom: 10px;
      }

      .equation-large {
        font-size: 28px;
        color: #222222;
        margin-top: 18px;
        margin-bottom: 12px;
        text-align: left;
      }

      .observed-equation {
        font-size: 20px;
        color: #222222;
        margin-top: 8px;
        margin-bottom: 6px;
        text-align: left;
      }

      .slide-table-wrapper {
        display: flex;
        gap: 32px;
        align-items: flex-start;
        margin-top: 14px;
      }

      .slide-table-block {
        width: 48%;
      }

      table.slide-table {
        width: 100%;
        border-collapse: collapse;
        font-size: 14px;
        text-align: center;
        background-color: white;
      }

      table.slide-table th {
        border-top: 3px solid #222222;
        border-bottom: 2px solid #222222;
        padding: 7px 10px;
        font-size: 14px;
        text-align: center;
        font-weight: 700;
      }

      table.slide-table td {
        border-bottom: 1px solid #e5e5e5;
        padding: 7px 10px;
      }

      table.slide-table tfoot td {
        border-top: 3px solid #222222;
        border-bottom: 3px solid #222222;
        font-weight: 700;
        font-size: 24px;
        padding-top: 10px;
        padding-bottom: 10px;
      }

      .original-fed {
        background-color: #f6dfcf;
      }

      .original-starved {
        background-color: #ffffff;
      }

      .permutation-subtitle {
        font-size: 30px;
        color: #315f96;
        margin-bottom: 12px;
      }

      .histogram-note {
        font-size: 16px;
        color: #444444;
      }

      .nav-tabs > li > a {
        font-size: 17px;
      }

      .explanation-tab {
        max-width: 900px;
        font-size: 18px;
        line-height: 1.45;
      }

      .explanation-tab h3 {
        color: #315f96;
        font-size: 30px;
        font-weight: 400;
        margin-top: 12px;
        margin-bottom: 18px;
      }

      .explanation-tab p {
        margin-bottom: 14px;
      }

      .original-slide-layout {
        display: grid;
        grid-template-columns: minmax(0, 40%) minmax(0, 60%);
        column-gap: 42px;
        align-items: start;
        padding: 8px 4px 4px 4px;
        background-color: #ffffff;
      }

      .original-slide-left {
        min-width: 0;
        padding-left: 2px;
      }

      .original-slide-right {
        min-width: 0;
        padding-top: 8px;
      }

      .lecture-table-title {
        font-size: 16px;
        line-height: 1.3;
        font-weight: 700;
        letter-spacing: 0.1px;
        margin-bottom: 16px;
        max-width: 100%;
      }

      .lecture-link {
        color: #008c95;
        text-decoration: underline;
        font-weight: 700;
      }

      .original-slide-tables {
        display: grid;
        grid-template-columns: minmax(0, 47%) minmax(0, 47%);
        column-gap: 42px;
        align-items: start;
      }

      table.original-lecture-table {
        width: 100%;
        border-collapse: collapse;
        font-size: 17px;
        background-color: white;
      }

      table.original-lecture-table th {
        border-bottom: 3px solid #16323a;
        padding: 5px 9px;
        text-align: left;
        font-weight: 700;
      }

      table.original-lecture-table td {
        border-bottom: 1px solid #e8e8e8;
        padding: 7px 9px;
      }

      table.original-lecture-table td:nth-child(2),
      table.original-lecture-table th:nth-child(2) {
        text-align: center;
      }

      table.original-lecture-table tfoot td {
        border-top: 3px solid #16323a;
        border-bottom: 3px solid #16323a;
        padding-top: 9px;
        padding-bottom: 9px;
        font-weight: 400;
      }

      .blank-row td {
        height: 24px;
        border-bottom: none !important;
      }

      .lecture-equation {
        font-size: 28px;
        line-height: 1.1;
        margin-top: 42px;
        text-align: left;
        color: #000000;
        padding-left: 28px;
      }

      .permutation-layout {
        display: grid;
        grid-template-columns: minmax(0, 40%) minmax(0, 60%);
        column-gap: 28px;
        align-items: start;
      }

      .permutation-left {
        min-width: 0;
      }

      .permutation-right {
        min-width: 0;
        padding-top: 0;
      }

      .permutation-histogram-text {
        font-size: 17px;
        line-height: 1.35;
        margin-bottom: 10px;
      }

      .permutation-note {
        font-size: 17px;
        line-height: 1.35;
        margin-bottom: 12px;
      }

      @media (max-width: 1100px) {
        .original-slide-layout {
          grid-template-columns: 1fr;
          row-gap: 28px;
        }

        .original-slide-tables {
          column-gap: 24px;
        }

        .lecture-equation {
          font-size: 32px;
        }

        .permutation-layout {
          grid-template-columns: 1fr;
          row-gap: 24px;
        }

        .permutation-right {
          padding-top: 0;
        }
      }
    "))
  ),

  shiny::titlePanel(
    shiny::div(
      class = "app-title",
      "Permutation tests: building a null distribution"
    )
  ),

  shiny::div(
    class = "explanation-box",
    shiny::tags$div(
      class = "observed-equation",
      shiny::HTML(
        paste0(
          "Observed: Ȳ<sub>starved</sub> − Ȳ<sub>fed</sub> = ",
          round(observed_starved_mean, 2),
          " − ",
          round(observed_fed_mean, 2),
          " = ",
          round(observed_difference, 2),
          " hours"
        )
      )
    )
  ),

  shiny::sidebarLayout(

    shiny::sidebarPanel(
      width = 2,

      shiny::div(
        class = "control-box",
        shiny::h4("Build the null distribution"),

        shiny::actionButton("permute_once", "Permute once", width = "100%"),
        shiny::br(), shiny::br(),

        shiny::actionButton("permute_10", "Run 10 more", width = "100%"),
        shiny::br(), shiny::br(),


        shiny::actionButton("permute_1000", "Run 1000 more", width = "100%"),
        shiny::br(), shiny::br(),

        shiny::actionButton("reset", "Reset", width = "100%")
      ),

      shiny::div(
        class = "control-box current-progress-text",
        shiny::h4(class = "current-progress-heading", "Current progress"),
        shiny::textOutput("n_permutations"),
        shiny::textOutput("n_lower_tail"),
        shiny::uiOutput("p_value_summary")
      )
    ),

    shiny::mainPanel(
      width = 10,

      shiny::tabsetPanel(

        shiny::tabPanel(
          "Explanation",
          shiny::br(),
          shiny::div(
            class = "explanation-tab",
            shiny::h3("How to use this app"),
            shiny::p("This app uses the sagebrush cricket data from Johnson et al. 1999, showcased in Example 13.5 of ABD. The 'Original data' tab reproduces Table 13.8-1 for reference."),
            shiny::p("The 'Permutatation' tab allows you to perform and visualize permutations. Each permutation randomly reassigns the observed times into two groups with the same sample sizes as the original study: 11 starved and 13 fed."),
            shiny::p("The app shows one randomized outcome at a time while also building a histogram of the mean differences from all permutations generated so far. The treatment names are retained, but the observed times have been randomly reassigned. Pale orange undershading identifies values that originally came from the fed group."),
            shiny::p("The histogram is built from all permutations generated so far. The goal is to understand what kinds of mean differences are plausible under the null hypothesis. The red bars show permuted mean differences that are less than or equal to the observed study difference of -18.26 hours.")
          )
        ),

        shiny::tabPanel(
          "Original data",
          shiny::br(),
          shiny::div(
            class = "original-slide-layout",

            shiny::div(
              class = "original-slide-left",

              shiny::div(
                class = "lecture-table-title",
                shiny::HTML(
                  "Times to mating (in hours) of female sagebrush crickets that were recently starved or fed. Data from the two treatments are color-coded to more easily identify the origin of each value later in the <span class='lecture-link'>Permutation</span> tab."
                )
              ),

              shiny::uiOutput("original_slide_table_only"),

              shiny::div(
                class = "lecture-equation",
                shiny::HTML(
                  paste0(
                    "Ȳ<sub>1</sub> − Ȳ<sub>2</sub> = ",
                    round(observed_starved_mean, 2),
                    " − ",
                    round(observed_fed_mean, 2),
                    " = ",
                    round(observed_difference, 2)
                  )
                )
              )
            ),

            shiny::div(
              class = "original-slide-right",
              shiny::plotOutput("original_histograms", height = "540px")
            )
          )
        ),

        shiny::tabPanel(
          "Permutation",
          shiny::br(),
          shiny::div(
            class = "permutation-layout",

            shiny::div(
              class = "permutation-left",

              shiny::div(class = "permutation-subtitle", "Most recent permutation"),

              shiny::p(
                class = "permutation-note",
                shiny::HTML(
                  "If more than one permutation is performed using the buttons to the left, <strong>only the most recent permutation is shown</strong>."
                )
              ),

              shiny::uiOutput("current_permutation_slide_table"),

              shiny::uiOutput("current_permutation_equation")
            ),

            shiny::div(
              class = "permutation-right",

              shiny::div(class = "permutation-subtitle", "The null distribution"),

              shiny::div(
                class = "permutation-histogram-text",
                shiny::HTML(
                  "Each permutation contributes one value of Ȳ<sub>1</sub> − Ȳ<sub>2</sub> to this histogram."
                )
              ),

              shiny::plotOutput("null_histogram", height = "420px"),

              shiny::uiOutput("histogram_explanation")
            )
          )
        )
      )
    )
  ),

  shiny::div(
    class = "footer-note",
    "Developed by ",
    shiny::tags$a(
      href = "https://vbaliga.github.io/",
      target = "_blank",
      rel = "noopener noreferrer",
      "Vikram Baliga"
    ),
    " at the University of British Columbia, using resources associated with ",
    shiny::tags$a(
      href = "https://whitlockschluter3e.zoology.ubc.ca/index.html",
      target = "_blank",
      rel = "noopener noreferrer",
      "The Analysis of Biological Data"
    ),
    " by Whitlock & Schluter."
  )
)

server <- function(input, output, session) {

  permutation_history <- shiny::reactiveVal(tibble::tibble(permutation_id = integer(),
                                            permuted_difference = numeric()))

  current_permutation <- shiny::reactiveVal(NULL)

  current_permutation_summary <- shiny::reactiveVal(NULL)

  add_permutations <- function(n) {
    old_history <- permutation_history()
    old_n <- nrow(old_history)

    new_results <- purrr::map(seq_len(n), function(i) {
      result <- permute_once(cricket_data)

      if (i == n) {
        current_permutation(result$permuted_data)
        current_permutation_summary(
          tibble::tibble(
            randomized_starved_mean = result$randomized_starved_mean,
            randomized_fed_mean = result$randomized_fed_mean,
            permuted_difference = result$permuted_difference
          )
        )
      }

      tibble::tibble(
        permutation_id = old_n + i,
        permuted_difference = result$permuted_difference
      )
    }) |>
      dplyr::bind_rows()

    permutation_history(dplyr::bind_rows(old_history, new_results))
  }

  shiny::observeEvent(input$permute_once, {
    add_permutations(1)
  })

  shiny::observeEvent(input$permute_10, {
    add_permutations(10)
  })

  shiny::observeEvent(input$permute_100, {
    add_permutations(100)
  })

  shiny::observeEvent(input$permute_1000, {
    add_permutations(1000)
  })

  shiny::observeEvent(input$reset, {
    permutation_history(tibble::tibble(permutation_id = integer(),
                               permuted_difference = numeric()))
    current_permutation(NULL)
    current_permutation_summary(NULL)
  })

  output$original_slide_table_only <- shiny::renderUI({
    starved_data <- cricket_data |>
      dplyr::filter(original_group == "Starved") |>
      dplyr::arrange(time_hours)

    fed_data <- cricket_data |>
      dplyr::filter(original_group == "Fed") |>
      dplyr::arrange(time_hours)

    starved_rows <- lapply(seq_len(nrow(starved_data)), function(i) {
      shiny::tags$tr(
        class = "original-starved",
        shiny::tags$td("Starved"),
        shiny::tags$td(starved_data$time_hours[i])
      )
    })

    fed_rows <- lapply(seq_len(nrow(fed_data)), function(i) {
      shiny::tags$tr(
        class = "original-fed",
        shiny::tags$td("Fed"),
        shiny::tags$td(fed_data$time_hours[i])
      )
    })

    ## Add blank rows to the shorter table so the two means align visually,
    ## as in the lecture slide.
    starved_rows <- c(
      starved_rows,
      list(
        shiny::tags$tr(class = "blank-row", shiny::tags$td(""), shiny::tags$td("")),
        shiny::tags$tr(class = "blank-row", shiny::tags$td(""), shiny::tags$td(""))
      )
    )

    shiny::div(
      class = "original-slide-tables",

      shiny::tags$table(
        class = "original-lecture-table",
        shiny::tags$thead(
          shiny::tags$tr(
            shiny::tags$th("Treatment"),
            shiny::tags$th("Time (hours)")
          )
        ),
        shiny::tags$tbody(starved_rows),
        shiny::tags$tfoot(
          shiny::tags$tr(
            shiny::tags$td("Mean"),
            shiny::tags$td(round(observed_starved_mean, 2))
          )
        )
      ),

      shiny::tags$table(
        class = "original-lecture-table",
        shiny::tags$thead(
          shiny::tags$tr(
            shiny::tags$th("Treatment"),
            shiny::tags$th("Time (hours)")
          )
        ),
        shiny::tags$tbody(fed_rows),
        shiny::tags$tfoot(
          shiny::tags$tr(
            shiny::tags$td("Mean"),
            shiny::tags$td(round(observed_fed_mean, 2))
          )
        )
      )
    )
  })

  output$original_histograms <- shiny::renderPlot({
    cricket_data |>
      ggplot2::ggplot(ggplot2::aes(x = time_hours)) +
      ggplot2::geom_histogram(
        binwidth = 20,
        boundary = 0,
        closed = "left",
        fill = "#d20a11",
        color = "#222222",
        linewidth = 0.7
      ) +
      ggplot2::facet_wrap(
        ggplot2::vars(original_group),
        ncol = 1,
        scales = "free_y",
        labeller = ggplot2::as_labeller(c(
          "Starved" = "Starved females",
          "Fed" = "Fed females"
        ))
      ) +
      ggplot2::scale_x_continuous(
        limits = c(0, 100),
        breaks = seq(0, 100, 20),
        expand = c(0, 0)
      ) +
      ggplot2::scale_y_continuous(
        breaks = seq(0, 8, 2),
        expand = ggplot2::expansion(mult = c(0, 0.12))
      ) +
      ggplot2::labs(
        x = "Time to mating (hours)",
        y = "Frequency"
      ) +
      statsapps_plot_theme(base_size = 18) +
      ggplot2::theme(
        strip.background = ggplot2::element_blank(),
        strip.text = ggplot2::element_text(
          face = "italic",
          size = 19,
          hjust = 0.86,
          color = "#222222"
        ),
        axis.title = ggplot2::element_text(face = "bold", size = 19),
        axis.title.y = ggplot2::element_text(margin = ggplot2::margin(r = 12)),
        axis.title.x = ggplot2::element_text(margin = ggplot2::margin(t = 12)),
        axis.text = ggplot2::element_text(color = "#222222", size = 16),
        axis.line = ggplot2::element_line(color = "#222222", linewidth = 0.7),
        axis.ticks = ggplot2::element_line(color = "#222222", linewidth = 0.7),
        panel.spacing = ggplot2::unit(1.7, "lines"),
        plot.margin = ggplot2::margin(4, 18, 4, 4)
      )
  })

  output$current_permutation_slide_table <- shiny::renderUI({
    shiny::validate(
      shiny::need(!is.null(current_permutation()), "Click 'Permute once' or run a batch of permutations to display one randomized outcome.")
    )

    permutation_data <- current_permutation()

    starved_data <- make_slide_table(permutation_data, "Starved")
    fed_data <- make_slide_table(permutation_data, "Fed")

    starved_mean <- mean(starved_data$time_hours)
    fed_mean <- mean(fed_data$time_hours)

    shiny::tagList(
      shiny::div(
        class = "slide-table-wrapper",

        shiny::div(
          class = "slide-table-block",
          shiny::tags$table(
            class = "slide-table",
            shiny::tags$thead(
              shiny::tags$tr(
                shiny::tags$th("Treatment"),
                shiny::tags$th("Time (hrs)")
              )
            ),
            shiny::tags$tbody(
              lapply(seq_len(nrow(starved_data)), function(i) {
                shiny::tags$tr(
                  class = starved_data$row_class[i],
                  shiny::tags$td("Starved"),
                  shiny::tags$td(starved_data$time_hours[i])
                )
              })
            ),
            shiny::tags$tfoot(
              shiny::tags$tr(
                shiny::tags$td("Mean"),
                shiny::tags$td(round(starved_mean, 2))
              )
            )
          )
        ),

        shiny::div(
          class = "slide-table-block",
          shiny::tags$table(
            class = "slide-table",
            shiny::tags$thead(
              shiny::tags$tr(
                shiny::tags$th("Treatment"),
                shiny::tags$th("Time (hrs)")
              )
            ),
            shiny::tags$tbody(
              lapply(seq_len(nrow(fed_data)), function(i) {
                shiny::tags$tr(
                  class = fed_data$row_class[i],
                  shiny::tags$td("Fed"),
                  shiny::tags$td(fed_data$time_hours[i])
                )
              })
            ),
            shiny::tags$tfoot(
              shiny::tags$tr(
                shiny::tags$td("Mean"),
                shiny::tags$td(round(fed_mean, 2))
              )
            )
          )
        )
      )
    )
  })

  output$current_permutation_equation <- shiny::renderUI({
    shiny::validate(
      shiny::need(!is.null(current_permutation_summary()), "")
    )

    summary <- current_permutation_summary()

    shiny::div(
      class = "equation-large",
      shiny::HTML(
        paste0(
          "Ȳ<sub>1</sub> − Ȳ<sub>2</sub> = ",
          round(summary$randomized_starved_mean, 2),
          " − ",
          round(summary$randomized_fed_mean, 2),
          " = ",
          round(summary$permuted_difference, 2)
        )
      )
    )
  })

  output$null_histogram <- shiny::renderPlot({
    history <- permutation_history()

    shiny::validate(
      shiny::need(nrow(history) > 0, "Click 'Permute once' or run a batch of permutations to begin building the null distribution.")
    )

    history <- history |>
      dplyr::mutate(
        lower_tail = permuted_difference <= observed_difference
      )

    ggplot2::ggplot(history, ggplot2::aes(x = permuted_difference)) +
      ggplot2::geom_histogram(
        data = dplyr::filter(history, !lower_tail),
        binwidth = 2,
        boundary = 0,
        fill = "white",
        color = "black"
      ) +
      ggplot2::geom_histogram(
        data = dplyr::filter(history, lower_tail),
        binwidth = 2,
        boundary = 0,
        fill = "#c92514",
        color = "black"
      ) +
      ggplot2::geom_vline(
        xintercept = observed_difference,
        linewidth = 1.1,
        color = "#555555"
      ) +
      ggplot2::annotate(
        "text",
        x = observed_difference,
        y = Inf,
        label = round(observed_difference, 2),
        vjust = 1.6,
        hjust = 1.1,
        size = 5,
        color = "#222222"
      ) +
      ggplot2::scale_x_continuous(
        limits = c(-50, 50),
        breaks = seq(-40, 40, 20),
        expand = c(0, 0)
      ) +
      ggplot2::scale_y_continuous(
        expand = ggplot2::expansion(mult = c(0, 0.1))
      ) +
      ggplot2::labs(
        x = "Difference in treatment means\nfrom randomized data (hours)",
        y = "Frequency"
      ) +
      statsapps_plot_theme(base_size = 20) +
      ggplot2::theme(
        axis.title = ggplot2::element_text(face = "bold"),
        # axis.title.x = element_text(
        #   size = 20,
        #   lineheight = 1.0,
        #   margin = margin(t = 10)
        # ),
        axis.text = ggplot2::element_text(color = "black"),
        plot.margin = ggplot2::margin(4, 6, 12, 6)
      )
  })

  output$n_permutations <- shiny::renderText({
    n <- nrow(permutation_history())
    paste0("Number of permutations generated: ", n)
  })

  output$n_lower_tail <- shiny::renderText({
    history <- permutation_history()

    if (nrow(history) == 0) {
      return("Lower-tail count: not yet available")
    }

    lower_tail_count <- sum(history$permuted_difference <= observed_difference)

    paste0(
      "Lower-tail count: ",
      lower_tail_count
    )
  })

  output$p_value_summary <- shiny::renderUI({
    history <- permutation_history()

    if (nrow(history) == 0) {
      return(shiny::tags$p("Two-tailed P-value: not yet available"))
    }

    lower_tail_count <- sum(history$permuted_difference <= observed_difference)
    lower_tail_proportion <- lower_tail_count / nrow(history)
    two_tailed_p <- 2 * lower_tail_proportion

    shiny::tags$div(
      shiny::tags$p(
        paste0(
          "Lower-tail proportion = ",
          lower_tail_count,
          " / ",
          nrow(history),
          " = ",
          round(lower_tail_proportion, 4)
        )
      ),
      shiny::tags$p(
        paste0(
          "Two-tailed P-value = 2 × ",
          round(lower_tail_proportion, 4),
          " = ",
          round(two_tailed_p, 4)
        )
      )
    )
  })

  output$histogram_explanation <- shiny::renderUI({
    history <- permutation_history()

    if (nrow(history) == 0) {
      return(shiny::tags$p("No permutations have been generated yet."))
    }

    lower_tail_count <- sum(history$permuted_difference <= observed_difference)
    lower_tail_proportion <- lower_tail_count / nrow(history)
    two_tailed_p <- 2 * lower_tail_proportion

    shiny::tags$div(
      class = "histogram-note",
      shiny::tags$p(
        paste0(
          lower_tail_count,
          " of ",
          nrow(history),
          " outcomes are less than or equal to the observed study difference of ",
          round(observed_difference, 2),
          " hours."
        )
      ),
      shiny::tags$p(
        paste0(
          "Two-tailed P-value = 2 × ",
          round(lower_tail_proportion, 4),
          " = ",
          round(two_tailed_p, 4)
        )
      )
    )
  })
}

shiny::shinyApp(ui = ui, server = server)

# GLOBAL SETTINGS FOR APPS

statsapps_plot_base_size <- 16

statsapps_plot_theme <- function(base_size = statsapps_plot_base_size) {
  ggplot2::theme_classic(base_size = base_size)
}

statsapps_plot_theme_code <- function(base_size = statsapps_plot_base_size) {
  paste0("theme_classic(base_size = ", base_size, ")")
}

test_that("all app.R files parse", {
  app_names <- c(
    "ANOVA",
    "distributions",
    "linear_reg",
    "permutation",
    "sums_squares"
  )

  app_dirs <- system.file("apps", app_names, package = "statsapps")
  app_files <- file.path(app_dirs, "app.R")

  for (app_file in app_files) {
    expect_no_error(parse(app_file))
  }
})

test_that("shared app files are bundled and parse", {
  shared_files <- c(
    system.file("app_shared", "app_settings.R", package = "statsapps"),
    system.file("app_shared", "statsapps.css", package = "statsapps")
  )

  expect_true(all(nzchar(shared_files)))
  expect_true(all(file.exists(shared_files)))

  expect_no_error(parse(shared_files[[1]]))
})

test_that("shared app settings define expected plotting helpers", {
  settings_file <- system.file(
    "app_shared",
    "app_settings.R",
    package = "statsapps"
  )

  settings_env <- new.env(parent = baseenv())
  source(settings_file, local = settings_env)

  expect_equal(settings_env$statsapps_plot_base_size, 16)
  expect_s3_class(settings_env$statsapps_plot_theme(), "theme")
  expect_equal(
    settings_env$statsapps_plot_theme_code(),
    "theme_classic(base_size = 16)"
  )
})

#' Launch the probability distributions app
#'
#' Opens an interactive Shiny app for exploring common probability distributions
#' used in BIOL 300.
#'
#' All data were simulated and don't come from a specific study.
#'
#' @inheritParams run_anova_app
#'
#' @return `run_distributions_app()` opens the Shiny app locally.
#'
#' @export
#'
#' @examplesIf interactive()
#' run_distributions_app()
run_distributions_app <- function(...) {
  run_statsapps_app("distributions", ...)
}

statsapps_shared_file <- function(...) {
  installed_file <- system.file("app_shared", ..., package = "statsapps")

  if (nzchar(installed_file)) {
    return(installed_file)
  }

  file.path("..", "..", "app_shared", ...)
}

source(statsapps_shared_file("app_settings.R"), local = TRUE)

distribution_choices <- c(
  "Binomial" = "binomial",
  "Chi-squared" = "chisq",
  "Poisson" = "poisson",
  "Uniform" = "uniform",
  "Normal" = "normal",
  "t" = "t",
  "F (ANOVA)" = "f"
)

distribution_label <- function(distribution) {
  switch(
    distribution,
    normal = "Normal distribution",
    t = "t distribution",
    uniform = "Uniform distribution",
    poisson = "Poisson distribution",
    binomial = "Binomial distribution",
    chisq = "Chi-squared distribution",
    f = "F distribution (ANOVA)"
  )
}

distribution_note <- function(distribution, params) {
  switch(
    distribution,
    normal = paste0(
      "This continuous probability distribution is shown with &mu; = ",
      format_number(params$mean), " and &sigma; = ",
      format_number(params$sd),
      ". Possible values range from &minus;&infin; to &infin;."
    ),
    t = paste0(
      "This continuous probability distribution is shown with df = ",
      format_number(params$df),
      ". Possible values range from &minus;&infin; to &infin;."
    ),
    uniform = paste0(
      "This continuous probability distribution is shown with minimum a = ",
      format_number(params$min), " and maximum b = ",
      format_number(params$max),
      ". Possible values range from a to b."
    ),
    poisson = paste0(
      "This discrete probability distribution models counts and is shown with &mu; = ",
      format_number(params$lambda),
      ". Possible values are whole numbers from 0 to &infin;; the final bar ",
      "combines the remaining upper tail."
    ),
    binomial = paste0(
      "This discrete probability distribution is shown with n = ",
      round(params$size), " trials and p = ",
      format_number(params$prob),
      ". Possible values are whole numbers from 0 to n."
    ),
    chisq = paste0(
      "This continuous probability distribution is shown with df = ",
      format_number(params$df),
      ". Possible values range from 0 to &infin;."
    ),
    f = paste0(
      "This continuous probability distribution is shown for an ANOVA F statistic ",
      "with df<sub>group</sub> = ", format_number(params$df_group),
      " and df<sub>error</sub> = ", format_number(params$df_error),
      ". Possible values range from 0 to &infin;."
    )
  )
}

distribution_formula <- function(distribution) {
  switch(
    distribution,
    normal = paste0(
      "\\[",
      "f(x) = \\frac{1}{\\sqrt{2\\pi\\sigma^2}} \\cdot ",
      "e^{-\\frac{(x - \\mu)^2}{2\\sigma^2}}",
      "\\]"
    ),
    t = paste0(
      "\\[",
      "f(t) = ",
      "\\frac{\\Gamma\\left(\\frac{\\mathrm{df} + 1}{2}\\right)}",
      "{\\sqrt{\\mathrm{df}\\pi}\\,\\Gamma\\left(\\frac{\\mathrm{df}}{2}\\right)}",
      "\\left(1 + \\frac{t^2}{\\mathrm{df}}\\right)^{-\\frac{\\mathrm{df} + 1}{2}}",
      "\\]"
    ),
    uniform = paste0(
      "\\[",
      "f(x) = \\frac{1}{b - a}, \\quad a \\le x \\le b",
      "\\]"
    ),
    poisson = paste0(
      "\\[",
      "\\Pr[X = x] = \\frac{\\mu^x \\cdot e^{-\\mu}}{x!}",
      "\\]"
    ),
    binomial = paste0(
      "\\[",
      "\\Pr[X = x] = {n \\choose x}p^x(1 - p)^{n - x}",
      "\\]"
    ),
    chisq = paste0(
      "\\[",
      "\\chi^2 = \\sum_i ",
      "\\frac{(\\mathrm{Observed}_i - \\mathrm{Expected}_i)^2}",
      "{\\mathrm{Expected}_i}",
      "\\]",
      "\\[",
      "\\Pr(\\chi^2 \\ge x) \\text{ is the right-tail area under the } ",
      "\\chi^2_{\\mathrm{df}} \\text{ distribution.}",
      "\\]"
    ),
    f = paste0(
      "\\[",
      "F = \\frac{MS_{\\mathrm{groups}}}{MS_{\\mathrm{error}}}",
      "\\]",
      "\\[",
      "df_{\\mathrm{group}} = k - 1, \\quad ",
      "df_{\\mathrm{error}} = N - k",
      "\\]",
      "\\[",
      "\\Pr(F \\ge x) \\text{ is the right-tail area under the } ",
      "F_{df_{\\mathrm{group}}, df_{\\mathrm{error}}} \\text{ distribution.}",
      "\\]"
    )
  )
}

distribution_formula_symbols <- function(distribution) {
  switch(
    distribution,
    normal = shiny::tagList(
      shiny::tags$p(shiny::HTML("<strong>Symbols:</strong> <em>x</em> is a possible value, &mu; is the mean, and &sigma; is the standard deviation."))
    ),
    t = shiny::tagList(
      shiny::tags$p(shiny::HTML("<strong>Symbols:</strong> <em>t</em> is a possible t statistic, and df is the degrees of freedom."))
    ),
    uniform = shiny::tagList(
      shiny::tags$p(shiny::HTML("<strong>Symbols:</strong> <em>x</em> is a possible value. Values between <em>a</em> and <em>b</em> have equal density."))
    ),
    poisson = shiny::tagList(
      shiny::tags$p(shiny::HTML("<strong>Symbols:</strong> <em>x</em> is a count. &mu; is the mean count, but in R this parameter is called lambda."))
    ),
    binomial = shiny::tagList(
      shiny::tags$p(shiny::HTML("<strong>Symbols:</strong> <em>x</em> is the number of successes, <em>n</em> is the number of trials, and <em>p</em> is the probability of success."))
    ),
    chisq = shiny::tagList(
      shiny::tags$p(
        shiny::HTML(
          "<strong>Symbols:</strong> <em>Observed</em><sub>i</sub> is an observed count, <em>Expected</em><sub>i</sub> is the expected count under the null hypothesis, <em>x</em> is a possible chi-squared value, and df is the degrees of freedom."
        )
      )
    ),
    f = shiny::tagList(
      shiny::tags$p(shiny::HTML("<strong>Symbols:</strong> <em>F</em> is the ANOVA test statistic, <em>x</em> is a possible F value, df<sub>group</sub> is the numerator degrees of freedom, and df<sub>error</sub> is the denominator degrees of freedom."))
    )
  )
}

x_axis_label <- function(distribution, params) {
  switch(
    distribution,
    normal = as.expression(bquote(x)),
    t = as.expression(bquote(t[.(params$df)])),
    uniform = as.expression(bquote(x)),
    poisson = as.expression(bquote(x~"(count)")),
    binomial = as.expression(bquote(x~"(number of successes)")),
    chisq = as.expression(
      bquote(chi^2~.(paste0("(df = ", format_number(params$df), ")")))
    ),
    f = as.expression(
      bquote(F[list(.(params$df_group), .(params$df_error))])
    )
  )
}

x_axis_label_code <- function(distribution, params) {
  switch(
    distribution,
    normal = "expression(x)",
    t = paste0("expression(t[", format_number(params$df), "])"),
    uniform = "expression(x)",
    poisson = "expression(x~\"(count)\")",
    binomial = "expression(x~\"(number of successes)\")",
    chisq = paste0(
      "expression(chi^2~\"(df = ",
      format_number(params$df),
      ")\")"
    ),
    f = paste0(
      "expression(F[list(",
      format_number(params$df_group), ", ",
      format_number(params$df_error),
      ")])"
    )
  )
}

format_number <- function(x) {
  format(signif(x, 6), trim = TRUE, scientific = FALSE)
}

is_valid_number <- function(x) {
  length(x) == 1 && !is.na(x) && is.finite(x)
}

parameter_values <- function(distribution, input) {
  switch(
    distribution,
    normal = list(
      mean = input$normal_mean,
      sd = input$normal_sd
    ),
    t = list(
      df = input$t_df
    ),
    uniform = list(
      min = input$uniform_min,
      max = input$uniform_max
    ),
    poisson = list(
      lambda = input$poisson_lambda
    ),
    binomial = list(
      size = input$binomial_size,
      prob = input$binomial_prob
    ),
    chisq = list(
      df = input$chisq_df
    ),
    f = list(
      df_group = input$f_df_group,
      df_error = input$f_df_error
    )
  )
}

validate_parameters <- function(distribution, params) {
  switch(
    distribution,
    normal = {
      if (!is_valid_number(params$mean)) {
        "Mean must be a finite number."
      } else if (!is_valid_number(params$sd) || params$sd <= 0) {
        "Standard deviation must be greater than 0."
      } else {
        NULL
      }
    },
    t = {
      if (!is_valid_number(params$df) || params$df <= 0) {
        "Degrees of freedom must be greater than 0."
      } else {
        NULL
      }
    },
    uniform = {
      if (!is_valid_number(params$min) || !is_valid_number(params$max)) {
        "Minimum and maximum must be finite numbers."
      } else if (params$max <= params$min) {
        "Maximum must be greater than minimum."
      } else {
        NULL
      }
    },
    poisson = {
      if (!is_valid_number(params$lambda) || params$lambda <= 0) {
        "Lambda must be greater than 0."
      } else {
        NULL
      }
    },
    binomial = {
      if (!is_valid_number(params$size) || params$size < 1) {
        "Number of trials must be at least 1."
      } else if (params$size != round(params$size)) {
        "Number of trials must be a whole number."
      } else if (!is_valid_number(params$prob) || params$prob < 0 || params$prob > 1) {
        "Probability must be between 0 and 1."
      } else {
        NULL
      }
    },
    chisq = {
      if (!is_valid_number(params$df) || params$df <= 0) {
        "Degrees of freedom must be greater than 0."
      } else {
        NULL
      }
    },
    f = {
      if (!is_valid_number(params$df_group) || params$df_group <= 0) {
        "Group degrees of freedom must be greater than 0."
      } else if (!is_valid_number(params$df_error) || params$df_error <= 0) {
        "Error degrees of freedom must be greater than 0."
      } else {
        NULL
      }
    }
  )
}

make_distribution_data <- function(distribution, params) {
  switch(
    distribution,
    normal = {
      x <- seq(
        stats::qnorm(0.001, mean = params$mean, sd = params$sd),
        stats::qnorm(0.999, mean = params$mean, sd = params$sd),
        length.out = 1000
      )

      list(
        type = "continuous",
        data = data.frame(
          x = x,
          density = stats::dnorm(x, mean = params$mean, sd = params$sd)
        )
      )
    },
    t = {
      x <- seq(
        stats::qt(0.001, df = params$df),
        stats::qt(0.999, df = params$df),
        length.out = 1000
      )

      list(
        type = "continuous",
        data = data.frame(
          x = x,
          density = stats::dt(x, df = params$df)
        )
      )
    },
    uniform = {
      x <- seq(
        params$min,
        params$max,
        length.out = 1000
      )

      list(
        type = "continuous",
        data = data.frame(
          x = x,
          density = stats::dunif(x, min = params$min, max = params$max)
        )
      )
    },
    poisson = {
      max_x <- stats::qpois(0.999, lambda = params$lambda)
      x <- 0:max_x
      tail_x <- max_x + 1

      list(
        type = "discrete",
        data = data.frame(
          x = c(x, tail_x),
          x_label = c(as.character(x), paste0("\u2265", tail_x)),
          probability = c(
            stats::dpois(x, lambda = params$lambda),
            1 - stats::ppois(max_x, lambda = params$lambda)
          )
        )
      )
    },
    binomial = {
      x <- 0:round(params$size)

      list(
        type = "discrete",
        data = data.frame(
          x = x,
          x_label = as.character(x),
          probability = stats::dbinom(
            x,
            size = round(params$size),
            prob = params$prob
          )
        )
      )
    },
    chisq = {
      x <- seq(
        0,
        stats::qchisq(0.999, df = params$df),
        length.out = 1000
      )

      list(
        type = "continuous",
        data = data.frame(
          x = x,
          density = stats::dchisq(x, df = params$df)
        )
      )
    },
    f = {
      x <- seq(
        0,
        stats::qf(
          0.999,
          df1 = params$df_group,
          df2 = params$df_error
        ),
        length.out = 1000
      )

      list(
        type = "continuous",
        data = data.frame(
          x = x,
          density = stats::df(
            x,
            df1 = params$df_group,
            df2 = params$df_error
          )
        )
      )
    }
  )
}

make_simulation_code <- function(distribution, params) {
  switch(
    distribution,
    normal = paste0(
      "set.seed(1)\n",
      "simulated_values <- rnorm(\n",
      "  n = 1000,\n",
      "  mean = ", format_number(params$mean), ",\n",
      "  sd = ", format_number(params$sd), "\n",
      ")"
    ),
    t = paste0(
      "set.seed(1)\n",
      "simulated_values <- rt(\n",
      "  n = 1000,\n",
      "  df = ", format_number(params$df), "\n",
      ")"
    ),
    uniform = paste0(
      "set.seed(1)\n",
      "simulated_values <- runif(\n",
      "  n = 1000,\n",
      "  min = ", format_number(params$min), ",\n",
      "  max = ", format_number(params$max), "\n",
      ")"
    ),
    poisson = paste0(
      "set.seed(1)\n",
      "simulated_values <- rpois(\n",
      "  n = 1000,\n",
      "  lambda = ", format_number(params$lambda), "\n",
      ")"
    ),
    binomial = paste0(
      "set.seed(1)\n",
      "simulated_values <- rbinom(\n",
      "  n = 1000,\n",
      "  size = ", round(params$size), ",\n",
      "  prob = ", format_number(params$prob), "\n",
      ")"
    ),
    chisq = paste0(
      "set.seed(1)\n",
      "simulated_values <- rchisq(\n",
      "  n = 1000,\n",
      "  df = ", format_number(params$df), "\n",
      ")"
    ),
    f = paste0(
      "set.seed(1)\n",
      "df_group <- ", format_number(params$df_group), "\n",
      "df_error <- ", format_number(params$df_error), "\n\n",
      "simulated_values <- rf(\n",
      "  n = 1000,\n",
      "  df1 = df_group,\n",
      "  df2 = df_error\n",
      ")"
    )
  )
}

make_plot_code <- function(distribution, params) {
  switch(
    distribution,
    normal = paste0(
      "library(ggplot2)\n\n",
      "x <- seq(\n",
      "  qnorm(0.001, mean = ", format_number(params$mean),
      ", sd = ", format_number(params$sd), "),\n",
      "  qnorm(0.999, mean = ", format_number(params$mean),
      ", sd = ", format_number(params$sd), "),\n",
      "  length.out = 1000\n",
      ")\n\n",
      "density <- dnorm(x, mean = ", format_number(params$mean),
      ", sd = ", format_number(params$sd), ")\n\n",
      "plot_data <- data.frame(x = x, density = density)\n\n",
      "ggplot(plot_data, aes(x = x, y = density)) +\n",
      "  geom_area(alpha = 0.2) +\n",
      "  geom_line(linewidth = 1.2) +\n",
      "  labs(x = ", x_axis_label_code(distribution, params),
      ", y = \"Density\") +\n",
      "  theme_classic()"
    ),
    t = paste0(
      "library(ggplot2)\n\n",
      "x <- seq(\n",
      "  qt(0.001, df = ", format_number(params$df), "),\n",
      "  qt(0.999, df = ", format_number(params$df), "),\n",
      "  length.out = 1000\n",
      ")\n\n",
      "density <- dt(x, df = ", format_number(params$df), ")\n\n",
      "plot_data <- data.frame(x = x, density = density)\n\n",
      "ggplot(plot_data, aes(x = x, y = density)) +\n",
      "  geom_area(alpha = 0.2) +\n",
      "  geom_line(linewidth = 1.2) +\n",
      "  labs(x = ", x_axis_label_code(distribution, params),
      ", y = \"Density\") +\n",
      "  theme_classic()"
    ),
    uniform = paste0(
      "library(ggplot2)\n\n",
      "x <- seq(\n",
      "  ", format_number(params$min), ",\n",
      "  ", format_number(params$max), ",\n",
      "  length.out = 1000\n",
      ")\n\n",
      "density <- dunif(x, min = ", format_number(params$min),
      ", max = ", format_number(params$max), ")\n\n",
      "plot_data <- data.frame(x = x, density = density)\n\n",
      "ggplot(plot_data, aes(x = x, y = density)) +\n",
      "  geom_area(alpha = 0.2) +\n",
      "  geom_line(linewidth = 1.2) +\n",
      "  labs(x = ", x_axis_label_code(distribution, params),
      ", y = \"Density\") +\n",
      "  theme_classic()"
    ),
    poisson = paste0(
      "library(ggplot2)\n\n",
      "max_x <- qpois(0.999, lambda = ", format_number(params$lambda), ")\n",
      "x <- 0:max_x\n",
      "tail_x <- max_x + 1\n\n",
      "probability <- c(\n",
      "  dpois(x, lambda = ", format_number(params$lambda), "),\n",
      "  1 - ppois(max_x, lambda = ", format_number(params$lambda), ")\n",
      ")\n\n",
      "plot_data <- data.frame(\n",
      "  x = c(x, tail_x),\n",
      "  x_label = c(as.character(x), paste0(\"\u2265\", tail_x)),\n",
      "  probability = probability\n",
      ")\n\n",
      "ggplot(plot_data, aes(x = x, y = probability)) +\n",
      "  geom_col() +\n",
      "  scale_x_continuous(\n",
      "    breaks = plot_data$x,\n",
      "    labels = plot_data$x_label\n",
      "  ) +\n",
      "  labs(x = ", x_axis_label_code(distribution, params),
      ", y = \"Probability\") +\n",
      "  theme_classic()"
    ),
    binomial = paste0(
      "library(ggplot2)\n\n",
      "x <- 0:", round(params$size), "\n\n",
      "probability <- dbinom(\n",
      "  x,\n",
      "  size = ", round(params$size), ",\n",
      "  prob = ", format_number(params$prob), "\n",
      ")\n\n",
      "plot_data <- data.frame(x = x, probability = probability)\n\n",
      "ggplot(plot_data, aes(x = x, y = probability)) +\n",
      "  geom_col() +\n",
      "  scale_x_continuous(breaks = x) +\n",
      "  labs(x = ", x_axis_label_code(distribution, params),
      ", y = \"Probability\") +\n",
      "  theme_classic()"
    ),
    chisq = paste0(
      "library(ggplot2)\n\n",
      "x <- seq(\n",
      "  0,\n",
      "  qchisq(0.999, df = ", format_number(params$df), "),\n",
      "  length.out = 1000\n",
      ")\n\n",
      "density <- dchisq(x, df = ", format_number(params$df), ")\n\n",
      "plot_data <- data.frame(x = x, density = density)\n\n",
      "ggplot(plot_data, aes(x = x, y = density)) +\n",
      "  geom_area(alpha = 0.2) +\n",
      "  geom_line(linewidth = 1.2) +\n",
      " labs(x = ", x_axis_label_code(distribution, params),
      ", y = \"Density\") +\n",
      "  theme_classic()"
    ),
    f = paste0(
      "library(ggplot2)\n\n",
      "df_group <- ", format_number(params$df_group), "\n",
      "df_error <- ", format_number(params$df_error), "\n\n",
      "x <- seq(\n",
      "  0,\n",
      "  qf(0.999, df1 = df_group, df2 = df_error),\n",
      "  length.out = 1000\n",
      ")\n\n",
      "density <- df(x, df1 = df_group, df2 = df_error)\n\n",
      "plot_data <- data.frame(x = x, density = density)\n\n",
      "ggplot(plot_data, aes(x = x, y = density)) +\n",
      "  geom_area(alpha = 0.2) +\n",
      "  geom_line(linewidth = 1.2) +\n",
      "  labs(x = ", x_axis_label_code(distribution, params),
      ", y = \"Density\") +\n",
      "  theme_classic()"
    )
  )
}

ui <- shiny::fluidPage(
  shiny::tags$head(
    shiny::includeCSS(statsapps_shared_file("statsapps.css")),
    shiny::tags$style(shiny::HTML("

      .distribution-subtitle {
        font-size: 30px;
        color: #315f96;
        margin-top: 24px;
        margin-bottom: 12px;
      }

      .code-grid {
        display: grid;
        grid-template-columns: minmax(0, 1fr) minmax(0, 1fr);
        column-gap: 24px;
        row-gap: 20px;
        margin-top: 12px;
      }

      .code-cell {
        min-width: 0;
      }

      .code-cell h4 {
        color: #315f96;
        font-weight: 400;
        margin-top: 0;
      }

      .code-cell pre {
        white-space: pre-wrap;
        word-break: normal;
      }

      @media (max-width: 1100px) {
        .code-grid {
          grid-template-columns: 1fr;
        }
      }

      .equation-box {
        background-color: #ffffff;
        border: 1px solid #dddddd;
        border-radius: 4px;
        padding: 12px;
        margin-top: 18px;
        overflow-x: auto;
      }

      .equation-box h4 {
        color: #315f96;
        font-weight: 400;
        margin-top: 0;
        margin-bottom: 8px;
      }

      .formula-symbols {
        font-size: 14px;
        line-height: 1.35;
        margin-top: 10px;
      }

      .formula-symbols p {
        margin-bottom: 6px;
      }
    "))
  ),

  shiny::titlePanel(
    shiny::div(
      class = "app-title",
      "Exploring probability distributions"
    )
  ),

  shiny::sidebarLayout(
    shiny::sidebarPanel(
      width = 4,

      shiny::tags$p(
        class = "control-note",
        "Choose a probability distribution, then adjust its parameter values.
        The plot and example R code will update automatically."
      ),

      shiny::selectInput(
        inputId = "distribution",
        label = "Distribution",
        choices = distribution_choices,
        selected = "binomial"
      ),

      shiny::uiOutput("parameter_inputs"),

      shiny::uiOutput("distribution_equation")
    ),

    shiny::mainPanel(
      width = 8,

      shiny::div(
        class = "distribution-subtitle",
        shiny::textOutput("distribution_title", inline = TRUE)
      ),

      shiny::uiOutput("distribution_note"),

      shiny::plotOutput("distribution_plot", height = "430px"),

      shiny::div(
        class = "distribution-subtitle",
        "R code"
      ),

      shiny::tags$p(
        class = "code-note",
        "The first code block simulates random observations from the chosen
        probability distribution and the parameter values you have specified.
        The second block provides code to plot the distribution with ggplot2."
      ),

      shiny::div(
        class = "code-grid",

        shiny::div(
          class = "code-cell",
          shiny::tags$h4("Simulate values"),
          shiny::verbatimTextOutput("simulation_code")
        ),

        shiny::div(
          class = "code-cell",
          shiny::tags$h4("Plot the distribution"),
          shiny::verbatimTextOutput("plot_code")
        )
      )
    )
  ),

  shiny::div(
    class = "footer-note",
    "Developed by ",
    shiny::tags$a(
      href = "https://vbaliga.github.io/",
      target = "_blank",
      rel = "noopener noreferrer",
      "Vikram Baliga"
    ),
    " at the University of British Columbia."
  )
)

server <- function(input, output, session) {
  output$parameter_inputs <- shiny::renderUI({
    shiny::req(input$distribution)

    switch(
      input$distribution,
      normal = shiny::tagList(
        shiny::numericInput(
          "normal_mean",
          shiny::HTML("Mean (&mu;)"),
          value = 0
        ),
        shiny::numericInput(
          "normal_sd",
          shiny::HTML("Standard deviation (&sigma;)"),
          value = 1,
          min = 0.0001
        )
      ),
      t = shiny::tagList(
        shiny::numericInput(
          "t_df",
          "Degrees of freedom (df)",
          value = 10,
          min = 0.0001
        )
      ),
      uniform = shiny::tagList(
        shiny::numericInput(
          "uniform_min",
          "Minimum (a)",
          value = 0
        ),
        shiny::numericInput(
          "uniform_max",
          "Maximum (b)",
          value = 1
        )
      ),
      poisson = shiny::tagList(
        shiny::numericInput(
          "poisson_lambda",
          shiny::HTML("Mean count (&mu;)"),
          value = 4.20,
          min = 0.0001
        )
      ),
      binomial = shiny::tagList(
        shiny::numericInput(
          "binomial_size",
          "Number of trials (n)",
          value = 10,
          min = 1,
          step = 1
        ),
        shiny::numericInput(
          "binomial_prob",
          "Probability of success (p)",
          value = 0.5,
          min = 0,
          max = 1,
          step = 0.05
        )
      ),
      chisq = shiny::tagList(
        shiny::numericInput(
          "chisq_df",
          "Degrees of freedom (df)",
          value = 5,
          min = 0.0001
        )
      ),
      f = shiny::tagList(
        shiny::numericInput(
          "f_df_group",
          shiny::HTML("Group degrees of freedom (df<sub>group</sub>)"),
          value = 9,
          min = 0.0001
        ),
        shiny::numericInput(
          "f_df_error",
          shiny::HTML("Error degrees of freedom (df<sub>error</sub>)"),
          value = 12,
          min = 0.0001
        )
      )
    )
  })

  current_distribution <- shiny::reactive({
    shiny::req(input$distribution)
    input$distribution
  })

  current_parameters <- shiny::reactive({
    parameter_values(current_distribution(), input)
  })

  current_parameter_message <- shiny::reactive({
    validate_parameters(current_distribution(), current_parameters())
  })

  output$distribution_title <- shiny::renderText({
    distribution_label(current_distribution())
  })

  output$distribution_note <- shiny::renderUI({
    message <- current_parameter_message()

    if (!is.null(message)) {
      return(
        shiny::tags$p(
          class = "plot-note",
          "Enter valid parameter values to show the distribution."
        )
      )
    }

    shiny::tags$p(
      class = "plot-note",
      shiny::HTML(
        distribution_note(
          distribution = current_distribution(),
          params = current_parameters()
        )
      )
    )
  })

  output$distribution_equation <- shiny::renderUI({
    shiny::div(
      class = "equation-box",
      shiny::tags$h4("Formula"),
      shiny::withMathJax(
        shiny::tagList(
          shiny::HTML(
            distribution_formula(current_distribution())
          ),
          shiny::div(
            class = "formula-symbols",
            distribution_formula_symbols(current_distribution())
          )
        )
      )
    )
  })

  output$distribution_plot <- shiny::renderPlot({
    message <- current_parameter_message()

    shiny::validate(
      shiny::need(is.null(message), message)
    )

    distribution_data <- make_distribution_data(
      distribution = current_distribution(),
      params = current_parameters()
    )

    x_label <- x_axis_label(
      distribution = current_distribution(),
      params = current_parameters()
    )

    if (identical(distribution_data$type, "continuous")) {
      ggplot2::ggplot(
        distribution_data$data,
        ggplot2::aes(x = x, y = density)
      ) +
        ggplot2::geom_area(
          fill = "#315f96",
          alpha = 0.18
        ) +
        ggplot2::geom_line(
          color = "#315f96",
          linewidth = 1.2
        ) +
        ggplot2::labs(
          x = x_label,
          y = "Density"
        ) +
        statsapps_plot_theme() +
        ggplot2::theme(
          axis.title = ggplot2::element_text(face = "bold"),
          axis.text = ggplot2::element_text(color = "#222222")
        )
    } else {
      ggplot2::ggplot(
        distribution_data$data,
        ggplot2::aes(x = x, y = probability)
      ) +
        ggplot2::geom_col(
          fill = "#315f96",
          color = "#222222",
          alpha = 0.85,
          width = 0.85
        ) +
        ggplot2::scale_x_continuous(
          breaks = distribution_data$data$x,
          labels = distribution_data$data$x_label
        ) +
        ggplot2::labs(
          x = x_label,
          y = "Probability"
        ) +
        statsapps_plot_theme() +
        ggplot2::theme(
          axis.title = ggplot2::element_text(face = "bold"),
          axis.text = ggplot2::element_text(color = "#222222")
        )
    }
  })

  output$simulation_code <- shiny::renderText({
    message <- current_parameter_message()

    if (!is.null(message)) {
      return(paste0("# ", message))
    }

    make_simulation_code(
      distribution = current_distribution(),
      params = current_parameters()
    )
  })

  output$plot_code <- shiny::renderText({
    message <- current_parameter_message()

    if (!is.null(message)) {
      return(paste0("# ", message))
    }

    make_plot_code(
      distribution = current_distribution(),
      params = current_parameters()
    )
  })
}

shiny::shinyApp(ui = ui, server = server)

#' Launch the permutation test app
#'
#' `run_permutation_app()` opens an interactive Shiny app that demonstrates how
#' repeated random reassignment of observations can be used to build a null
#' distribution for a two-sample permutation test.
#'
#' The app uses data on time to mating in female sagebrush crickets from
#' Johnson et al. (1999), as presented in *The Analysis of Biological Data* by
#' Whitlock and Schluter.
#'
#' @inheritParams run_anova_app
#'
#' @return `run_permutation_app()` opens the Shiny app locally.
#'
#' @references
#' Johnson, J. C., T. M. Ivy, and S. K. Sakaluk. 1999. Female remating
#' propensity contingent on sexual cannibalism in sagebrush crickets,
#' *Cyphoderris strepitans*: a mechanism of cryptic female choice.
#' *Behavioral Ecology* 10: 227-233.
#'
#' Whitlock, M. C., and D. Schluter. 2020. *The Analysis of Biological Data*.
#' 3rd ed. W. H. Freeman and Company.
#'
#' @importFrom dplyr arrange bind_rows filter if_else mutate pull row_number summarise
#' @importFrom ggplot2 aes annotate element_blank element_line element_text expansion facet_wrap geom_histogram geom_vline ggplot labs margin scale_x_continuous scale_y_continuous theme theme_classic vars
#' @importFrom purrr map
#' @importFrom tibble tibble
#'
#' @export
#'
#' @examplesIf interactive()
#' run_permutation_app()
run_permutation_app <- function(...) {
  run_statsapps_app("permutation", ...)
}

statsapps_shared_file <- function(...) {
  installed_file <- system.file("app_shared", ..., package = "statsapps")

  if (nzchar(installed_file)) {
    return(installed_file)
  }

  file.path("..", "..", "app_shared", ...)
}

source(statsapps_shared_file("app_settings.R"), local = TRUE)

group_colors <- c(
  "A" = "#F4A582",
  "B" = "#315f96",
  "C" = "#E7298A"
)

component_colors <- c(
  "Total" = "#4D4D4D",
  "Groups" = "#6A3D9A",
  "Error" = "#008C8C"
)

max_step <- 6

step_title <- function(step) {
  c(
    "Data only",
    "Overall mean",
    "Total deviations",
    "Group means",
    "Groups component",
    "Error component",
    "Sums of squares"
  )[step + 1]
}

step_description <- function(step) {
  c(
    "Start with the data points only. The groups have unequal sample sizes: A has 4 observations, while B and C have 3 each.",
    "The overall mean is computed from all observations together. Because the group sizes are unequal, this is not necessarily the same as the simple average of the three group means.",
    "Total variation compares each observation to the overall mean.",
    "Each group also has its own mean. These group means summarize where each group is centered.",
    "The groups component compares each group mean to the overall mean. Each observation contributes its group mean's deviation from the overall mean.",
    "The error component compares each observation to its own group mean. This is the within-group variation left over after accounting for group membership.",
    "The total sums of squares can be partitioned into a groups component and an error component."
  )[step + 1]
}

add_plot_positions <- function(data) {
  data$x_group <- as.integer(data$group)
  data$x <- NA_real_

  for (current_group in levels(data$group)) {
    rows <- which(data$group == current_group)
    center <- unique(data$x_group[rows])
    data$x[rows] <- center + seq(-0.16, 0.16, length.out = length(rows))
  }

  data
}

simulate_sums_squares_data <- function(seed = 20260710) {
  set.seed(seed)

  group_info <- data.frame(
    group = factor(c("A", "B", "C"), levels = c("A", "B", "C")),
    n = c(4, 3, 3),
    mean = c(8, 12, 18),
    sd = c(1.5, 1.8, 1.6)
  )

  data <- do.call(
    rbind,
    lapply(seq_len(nrow(group_info)), function(i) {
      data.frame(
        group = group_info$group[i],
        y = stats::rnorm(
          n = group_info$n[i],
          mean = group_info$mean[i],
          sd = group_info$sd[i]
        )
      )
    })
  )

  data$group <- factor(data$group, levels = c("A", "B", "C"))
  data$id <- seq_len(nrow(data))
  data <- add_plot_positions(data)

  data
}

summarize_sums_squares <- function(data) {
  grand_mean <- mean(data$y)

  group_summary <- stats::aggregate(
    y ~ group,
    data = data,
    FUN = function(x) c(n = length(x), mean = mean(x))
  )

  group_summary <- data.frame(
    group = group_summary$group,
    n = group_summary$y[, "n"],
    group_mean = group_summary$y[, "mean"]
  )

  group_summary$group <- factor(group_summary$group, levels = levels(data$group))
  group_summary$x_group <- as.integer(group_summary$group)

  data$group_mean <- group_summary$group_mean[
    match(data$group, group_summary$group)
  ]

  data$total_deviation <- data$y - grand_mean
  data$group_deviation <- data$group_mean - grand_mean
  data$error_deviation <- data$y - data$group_mean

  data$total_ss_component <- data$total_deviation^2
  data$group_ss_component <- data$group_deviation^2
  data$error_ss_component <- data$error_deviation^2

  list(
    data = data,
    group_summary = group_summary,
    grand_mean = grand_mean,
    mean_of_group_means = mean(group_summary$group_mean),
    ss_total = sum(data$total_ss_component),
    ss_groups = sum(data$group_ss_component),
    ss_error = sum(data$error_ss_component)
  )
}

make_square_data <- function(summary_object) {
  data <- summary_object$data
  grand_mean <- summary_object$grand_mean

  total_data <- data
  total_data$component <- "Total"
  total_data$start_y <- total_data$y
  total_data$end_y <- grand_mean

  groups_data <- data
  groups_data$component <- "Groups"
  groups_data$start_y <- groups_data$group_mean
  groups_data$end_y <- grand_mean

  error_data <- data
  error_data$component <- "Error"
  error_data$start_y <- error_data$y
  error_data$end_y <- error_data$group_mean

  square_data <- rbind(total_data, groups_data, error_data)

  square_data$component <- factor(
    square_data$component,
    levels = c("Total", "Groups", "Error")
  )

  square_data$deviation <- square_data$start_y - square_data$end_y
  square_data$abs_deviation <- abs(square_data$deviation)

  width_scale <- 0.055

  square_data$xmin <- square_data$x
  square_data$xmax <- square_data$x + width_scale * square_data$abs_deviation
  square_data$ymin <- pmin(square_data$start_y, square_data$end_y)
  square_data$ymax <- pmax(square_data$start_y, square_data$end_y)

  square_data
}

format_number <- function(x) {
  format(round(x, 2), nsmall = 2, trim = TRUE)
}

ui <- shiny::fluidPage(
  shiny::tags$head(
    shiny::includeCSS(statsapps_shared_file("statsapps.css")),
    shiny::tags$style(shiny::HTML("
      .ss-equation {
        font-size: 18px;
        line-height: 1.35;
        margin-top: 14px;
        margin-bottom: 12px;
      }

      .sidebar-equation {
        font-size: 16px;
        line-height: 1.35;
        margin-top: 8px;
        margin-bottom: 8px;
        text-align: left;
        overflow-x: auto;
      }

      .ss-total {
        color: #4D4D4D;
        font-weight: 600;
      }

      .ss-groups {
        color: #6A3D9A;
        font-weight: 600;
      }

      .ss-error {
        color: #008C8C;
        font-weight: 600;
      }

      .ss-value-line {
        font-size: 17px;
        line-height: 1.35;
        margin-top: 4px;
        margin-bottom: 8px;
      }

      .value-box {
        background-color: #f7f7f7;
        border: 1px solid #dddddd;
        border-radius: 4px;
        padding: 12px;
        margin-bottom: 12px;
      }

      .value-box h4 {
        color: #315f96;
        margin-top: 0;
      }

      .step-label {
        color: #315f96;
        font-size: 22px;
        margin-top: 8px;
        margin-bottom: 8px;
      }

      .button-row {
        margin-top: 14px;
        margin-bottom: 14px;
      }
    "))
  ),

  shiny::div(
    class = "app-title",
    "Partitioning sums of squares"
  ),

  shiny::sidebarLayout(
    shiny::sidebarPanel(
      shiny::tags$p(
        class = "control-note",
        "Build the ANOVA sums-of-squares decomposition one layer at a time.
        All data are simulated. Hit the \"Next\" button to proceed to the next
        step."
      ),

      shiny::div(
        class = "button-row",
        shiny::actionButton("previous_step", "Previous"),
        shiny::actionButton("next_step", "Next")
      ),

      shiny::hr(),

      shiny::uiOutput("step_panel"),

      shiny::hr(),

      shiny::actionButton("reset_step", "Reset"),
      shiny::actionButton("simulate_data", "Simulate new data"),

      shiny::hr(),

      shiny::uiOutput("values_panel")
    ),

    shiny::mainPanel(
      shiny::div(
        class = "app-subtitle",
        shiny::textOutput("step_title", inline = TRUE)
      ),

      shiny::tags$p(
        class = "plot-note",
        shiny::textOutput("step_description", inline = TRUE)
      ),

      shiny::plotOutput("main_plot", height = "470px"),

      shiny::uiOutput("breakdown_panel")
    )
  ),

  shiny::div(
    class = "footer-note",
    "Developed by ",
    shiny::tags$a(
      href = "https://vbaliga.github.io/",
      target = "_blank",
      rel = "noopener noreferrer",
      "Vikram Baliga"
    ),
    " at the University of British Columbia."
  )
)

server <- function(input, output, session) {
  current_step <- shiny::reactiveVal(0)
  data_seed <- shiny::reactiveVal(20260710)

  shiny::observeEvent(input$next_step, {
    current_step(min(current_step() + 1, max_step))
  })

  shiny::observeEvent(input$previous_step, {
    current_step(max(current_step() - 1, 0))
  })

  shiny::observeEvent(input$reset_step, {
    current_step(0)
  })

  shiny::observeEvent(input$simulate_data, {
    data_seed(data_seed() + 1)
    current_step(0)
  })

  current_data <- shiny::reactive({
    simulate_sums_squares_data(seed = data_seed())
  })

  current_summary <- shiny::reactive({
    summarize_sums_squares(current_data())
  })

  output$step_title <- shiny::renderText({
    step_title(current_step())
  })

  output$step_description <- shiny::renderText({
    step_description(current_step())
  })

  output$step_panel <- shiny::renderUI({
    shiny::tagList(
      shiny::tags$div(
        class = "step-label",
        paste0("Step ", current_step(), " of ", max_step)
      ),
      shiny::tags$p(step_description(current_step()))
    )
  })

  output$main_plot <- shiny::renderPlot({
    step <- current_step()
    summary_object <- current_summary()
    data <- summary_object$data
    group_summary <- summary_object$group_summary
    grand_mean <- summary_object$grand_mean

    plot_object <- ggplot2::ggplot() +
      ggplot2::scale_color_manual(values = group_colors) +
      ggplot2::scale_fill_manual(values = group_colors) +
      ggplot2::scale_x_continuous(
        breaks = c(1, 2, 3),
        labels = c("A", "B", "C"),
        limits = c(0.55, 3.55)
      ) +
      ggplot2::labs(
        x = "Group",
        y = "Y"
      ) +
      statsapps_plot_theme()

    if (step >= 1) {
      plot_object <- plot_object +
        ggplot2::geom_hline(
          yintercept = grand_mean,
          color = "#CC0000",
          linewidth = 1.1,
          linetype = "dashed"
        )
    }

    if (step == 2) {
      plot_object <- plot_object +
        ggplot2::geom_segment(
          data = data,
          ggplot2::aes(
            x = x,
            xend = x,
            y = y,
            yend = grand_mean
          ),
          color = "gray35",
          linewidth = 0.9
        )
    }

    if (step >= 3) {
      plot_object <- plot_object +
        ggplot2::geom_segment(
          data = group_summary,
          ggplot2::aes(
            x = x_group - 0.28,
            xend = x_group + 0.28,
            y = group_mean,
            yend = group_mean,
            color = group
          ),
          linewidth = 1.8
        )
    }

    if (step == 4) {
      plot_object <- plot_object +
        ggplot2::geom_segment(
          data = group_summary,
          ggplot2::aes(
            x = x_group,
            xend = x_group,
            y = group_mean,
            yend = grand_mean,
            color = group
          ),
          linewidth = 1.2
        )
    }

    if (step == 5) {
      plot_object <- plot_object +
        ggplot2::geom_segment(
          data = data,
          ggplot2::aes(
            x = x,
            xend = x,
            y = y,
            yend = group_mean,
            color = group
          ),
          linewidth = 0.9
        )
    }

    plot_object +
      ggplot2::geom_point(
        data = data,
        ggplot2::aes(x = x, y = y, fill = group),
        shape = 21,
        color = "black",
        size = 4,
        stroke = 0.7
      ) +
      ggplot2::theme(legend.position = "none")
  })

  output$values_panel <- shiny::renderUI({
    step <- current_step()
    summary_object <- current_summary()
    group_summary <- summary_object$group_summary

    if (step == 0) {
      return(NULL)
    }

    value_items <- list(
      shiny::tags$p(
        shiny::HTML(
          paste0(
            "<strong>Overall mean ",
            "\\(\\left(\\bar{Y}\\right)\\)",
            ":</strong> ",
            format_number(summary_object$grand_mean)
          )
        )
      )
    )

    if (step >= 3) {
      group_lines <- lapply(seq_len(nrow(group_summary)), function(i) {
        shiny::tags$li(
          paste0(
            "Group ",
            group_summary$group[i],
            ": n = ",
            group_summary$n[i],
            ", mean = ",
            format_number(group_summary$group_mean[i])
          )
        )
      })

      value_items <- c(
        value_items,
        list(
          shiny::tags$ul(group_lines)
        )
      )
    }

    if (step >= 4) {
      value_items <- c(
        value_items,
        list(
          shiny::tags$hr(),
          shiny::div(
            class = "sidebar-equation",
            shiny::HTML(
              paste0(
                "<span class='ss-groups'>\\(SS_{groups}\\)</span> ",
                "\\(= \\sum_i n_i\\left(\\bar{Y}_i - \\bar{Y}\\right)^2 =\\) ",
                "<span class='ss-groups'>",
                format_number(summary_object$ss_groups),
                "</span>"
              )
            )
          )
        )
      )
    }

    if (step >= 5) {
      value_items <- c(
        value_items,
        list(
          shiny::div(
            class = "sidebar-equation",
            shiny::HTML(
              paste0(
                "<span class='ss-error'>\\(SS_{error}\\)</span> ",
                "\\(= \\sum_i s_i^2\\left(n_i - 1\\right) =\\) ",
                "<span class='ss-error'>",
                format_number(summary_object$ss_error),
                "</span>"
              )
            )
          )
        )
      )
    }

    if (step >= 6) {
      value_items <- c(
        value_items,
        list(
          shiny::tags$hr(),
          shiny::div(
            class = "sidebar-equation",
            shiny::HTML(
              paste0(
                "<span class='ss-total'>\\(SS_{total}\\)</span> ",
                "\\(=\\) ",
                "<span class='ss-groups'>\\(SS_{groups}\\)</span> ",
                "\\(+\\) ",
                "<span class='ss-error'>\\(SS_{error}\\)</span>"
              )
            )
          ),
          shiny::div(
            class = "ss-value-line",
            shiny::HTML(
              paste0(
                "<span class='ss-total'>",
                format_number(summary_object$ss_total),
                "</span>",
                " = ",
                "<span class='ss-groups'>",
                format_number(summary_object$ss_groups),
                "</span>",
                " + ",
                "<span class='ss-error'>",
                format_number(summary_object$ss_error),
                "</span>"
              )
            )
          )
        )
      )
    }

    shiny::div(
      class = "value-box",
      shiny::tags$h4("Computed values"),
      shiny::withMathJax(
        shiny::tagList(value_items)
      )
    )
  })

  output$breakdown_panel <- shiny::renderUI({
    if (current_step() < 6) {
      return(NULL)
    }

    shiny::tagList(
      shiny::div(
        class = "app-subtitle",
        "Visual partition"
      ),
      shiny::tags$p(
        class = "plot-note",
        "The shaded rectangles represent squared deviations. Their sizes are visual guides; the exact sums are shown above."
      ),
      shiny::plotOutput("breakdown_plot", height = "380px")
    )
  })

  output$breakdown_plot <- shiny::renderPlot({
    summary_object <- current_summary()
    square_data <- make_square_data(summary_object)
    data <- summary_object$data
    group_summary <- summary_object$group_summary

    label_y <- max(data$y) + 0.08 * diff(range(data$y))

    component_label_data <- data.frame(
      component = factor(
        names(component_colors),
        levels = c("Total", "Groups", "Error")
      ),
      x = 0.62,
      y = label_y,
      label = names(component_colors)
    )

    ggplot2::ggplot() +
      ggplot2::geom_rect(
        data = square_data,
        ggplot2::aes(
          xmin = xmin,
          xmax = xmax,
          ymin = ymin,
          ymax = ymax,
          fill = group
        ),
        color = "black",
        alpha = 0.25
      ) +
      ggplot2::geom_segment(
        data = square_data,
        ggplot2::aes(
          x = x,
          xend = x,
          y = start_y,
          yend = end_y,
          color = group
        ),
        linewidth = 0.8
      ) +
      ggplot2::geom_point(
        data = data,
        ggplot2::aes(x = x, y = y, fill = group),
        shape = 21,
        color = "black",
        size = 3.5,
        stroke = 0.7
      ) +
      ggplot2::geom_hline(
        yintercept = summary_object$grand_mean,
        color = "#CC0000",
        linewidth = 0.9,
        linetype = "dashed"
      ) +
      ggplot2::geom_segment(
        data = group_summary,
        ggplot2::aes(
          x = x_group - 0.25,
          xend = x_group + 0.25,
          y = group_mean,
          yend = group_mean,
          color = group
        ),
        linewidth = 1.4
      ) +
      ggplot2::geom_text(
        data = component_label_data,
        ggplot2::aes(
          x = x,
          y = y,
          label = label,
          color = component
        ),
        hjust = 0,
        fontface = "bold",
        size = 5.5
      ) +
      ggplot2::facet_wrap(~ component, nrow = 1) +
      ggplot2::scale_color_manual(values = c(group_colors, component_colors)) +
      ggplot2::scale_fill_manual(values = group_colors) +
      ggplot2::scale_x_continuous(
        breaks = c(1, 2, 3),
        labels = c("A", "B", "C"),
        limits = c(0.55, 3.85)
      ) +
      ggplot2::scale_y_continuous(
        expand = ggplot2::expansion(mult = c(0.05, 0.18))
      ) +
      ggplot2::labs(
        x = "Group",
        y = "Y"
      ) +
      statsapps_plot_theme() +
      ggplot2::theme(
        legend.position = "none",
        strip.background = ggplot2::element_blank(),
        strip.text = ggplot2::element_blank()
      )
  })
}

shiny::shinyApp(ui = ui, server = server)

source_app_env <- function(app_name) {
  app_file <- system.file("apps", app_name, "app.R", package = "statsapps")

  expect_true(nzchar(app_file))
  expect_true(file.exists(app_file))

  app_env <- new.env(parent = globalenv())
  expect_no_error(source(app_file, local = app_env))

  app_env
}

test_that("sums_squares simulation has the expected group structure", {
  app_env <- source_app_env("sums_squares")

  data <- app_env$simulate_sums_squares_data(seed = 20260710)

  expect_s3_class(data, "data.frame")
  expect_equal(nrow(data), 10L)
  expect_equal(levels(data$group), c("A", "B", "C"))
  expect_equal(unname(as.integer(table(data$group))), c(4L, 3L, 3L))
  expect_equal(data$id, seq_len(nrow(data)))

  expect_true(all(c("group", "y", "id", "x_group", "x") %in% names(data)))
  expect_true(all(is.finite(data$y)))
  expect_true(all(is.finite(data$x)))
})

test_that("sums_squares simulation is reproducible by seed", {
  app_env <- source_app_env("sums_squares")

  data_1 <- app_env$simulate_sums_squares_data(seed = 20260710)
  data_2 <- app_env$simulate_sums_squares_data(seed = 20260710)
  data_3 <- app_env$simulate_sums_squares_data(seed = 20260711)

  expect_equal(data_1, data_2)
  expect_false(isTRUE(all.equal(data_1$y, data_3$y)))
})

test_that("sums_squares decomposition is internally consistent", {
  app_env <- source_app_env("sums_squares")

  data <- app_env$simulate_sums_squares_data(seed = 20260710)
  summary_object <- app_env$summarize_sums_squares(data)

  group_means <- ave(data$y, data$group, FUN = mean)
  grand_mean <- mean(data$y)

  expect_equal(
    summary_object$ss_total,
    sum((data$y - grand_mean)^2),
    tolerance = 1e-10
  )

  expect_equal(
    summary_object$ss_groups,
    sum((group_means - grand_mean)^2),
    tolerance = 1e-10
  )

  expect_equal(
    summary_object$ss_error,
    sum((data$y - group_means)^2),
    tolerance = 1e-10
  )

  expect_equal(
    summary_object$ss_total,
    summary_object$ss_groups + summary_object$ss_error,
    tolerance = 1e-10
  )
})

test_that("sums_squares square data are well formed", {
  app_env <- source_app_env("sums_squares")

  data <- app_env$simulate_sums_squares_data(seed = 20260710)
  summary_object <- app_env$summarize_sums_squares(data)
  square_data <- app_env$make_square_data(summary_object)

  expect_s3_class(square_data, "data.frame")
  expect_equal(nrow(square_data), 3L * nrow(data))
  expect_equal(levels(square_data$component), c("Total", "Groups", "Error"))

  expect_true(all(square_data$ymin <= square_data$ymax))
  expect_true(all(square_data$xmin <= square_data$xmax))
  expect_equal(
    square_data$abs_deviation,
    abs(square_data$deviation),
    tolerance = 1e-10
  )
})

test_that("sums_squares step helpers work for all defined steps", {
  app_env <- source_app_env("sums_squares")

  expect_equal(app_env$max_step, 6)

  expect_no_error(
    vapply(0:app_env$max_step, app_env$step_title, character(1))
  )

  expect_no_error(
    vapply(0:app_env$max_step, app_env$step_description, character(1))
  )
})

test_that("linear_reg simulation preserves the user's random seed", {
  app_env <- source_app_env("linear_reg")

  set.seed(12345)
  seed_before <- .Random.seed

  expect_no_error(app_env$simulate_linear_reg_data(seed = 20260713))

  seed_after <- .Random.seed

  expect_identical(seed_after, seed_before)
})

test_that("linear_reg simulated solution is recovered by lm", {
  app_env <- source_app_env("linear_reg")

  simulation <- app_env$simulate_linear_reg_data(seed = 20260713)
  data <- simulation$data

  x_model <- if (isTRUE(simulation$solution_log_x)) {
    log(data$x)
  } else {
    data$x
  }

  y_model <- if (isTRUE(simulation$solution_log_y)) {
    log(data$y)
  } else {
    data$y
  }

  fit <- stats::lm(y_model ~ x_model)

  expect_equal(
    unname(stats::coef(fit)[[1]]),
    simulation$solution_intercept,
    tolerance = 1e-10
  )

  expect_equal(
    unname(stats::coef(fit)[[2]]),
    simulation$solution_slope,
    tolerance = 1e-10
  )
})

test_that("linear_reg displayed simulation code reproduces the data", {
  app_env <- source_app_env("linear_reg")

  simulation <- app_env$simulate_linear_reg_data(seed = 20260713)
  code <- app_env$simulation_code_text(simulation)

  code_env <- new.env(parent = globalenv())

  expect_no_error(
    eval(parse(text = code), envir = code_env)
  )

  expect_equal(
    code_env$linreg_data,
    simulation$data,
    tolerance = 1e-10
  )
})

test_that("linear_reg relationship specs stay on the slider grid", {
  app_env <- source_app_env("linear_reg")

  intercept_values <- app_env$slider_values(
    app_env$intercept_range,
    app_env$intercept_step
  )

  slope_values <- app_env$slider_values(
    app_env$slope_range,
    app_env$slope_step
  )

  for (relationship_id in names(app_env$relationship_specs)) {
    spec <- app_env$relationship_specs[[relationship_id]]

    expect_true(all(spec$intercept_values %in% intercept_values))
    expect_true(all(spec$slope_values %in% slope_values))
  }
})

run_statsapps_app <- function(
    app_name,
    launch.browser = getOption("statsapps.launch.browser", TRUE),
    ...
) {
  app_dir <- system.file("apps", app_name, package = "statsapps")

  if (identical(app_dir, "")) {
    stop(
      "Could not find the ",
      app_name,
      " app. Try reinstalling statsapps.",
      call. = FALSE
    )
  }

  shiny::runApp(
    app_dir,
    launch.browser = launch.browser,
    ...
  )
}

#' Launch the sums of squares app
#'
#' Opens an interactive Shiny app for exploring how total variation can be
#' partitioned into group-level and within-group components in one-way ANOVA.
#'
#' @inheritParams run_anova_app
#'
#' @return `run_sums_squares_app()` opens the Shiny app locally.
#'
#' @export
#'
#' @examplesIf interactive()
#' run_sums_squares_app()
run_sums_squares_app <- function(...) {
  run_statsapps_app("sums_squares", ...)
}

#' Launch the simple linear regression app
#'
#' Opens an interactive Shiny app for exploring how the slope and intercept of a
#' linear model affect fitted values and residuals.
#'
#' All data were simulated and don't come from a specific study.
#'
#' @inheritParams run_anova_app
#'
#' @return `run_linear_reg_app()` opens the Shiny app locally.
#'
#' @importFrom ggplot2 aes after_stat element_text geom_histogram geom_hline geom_line geom_point geom_segment ggplot labs stat_function theme theme_classic
#'
#' @export
#'
#' @examplesIf interactive()
#' run_linear_reg_app()
run_linear_reg_app <- function(...) {
  run_statsapps_app("linear_reg", ...)
}

statsapps_shared_file <- function(...) {
  installed_file <- system.file("app_shared", ..., package = "statsapps")

  if (nzchar(installed_file)) {
    return(installed_file)
  }

  file.path("..", "..", "app_shared", ...)
}

source(statsapps_shared_file("app_settings.R"), local = TRUE)

group_colors <- c("firebrick", "goldenrod1", "#265AAE")

ui <- shiny::fluidPage(
  shiny::tags$head(
    shiny::includeCSS(statsapps_shared_file("statsapps.css")),
    shiny::tags$style(shiny::HTML("

      .boxplot-wrapper {
        margin-bottom: 14px;
      }

    "))
  ),

  shiny::titlePanel(
    shiny::div(
      class = "app-title",
      "One-Way ANOVA Simulator"
    )
  ),

  shiny::sidebarLayout(
    shiny::sidebarPanel(
      shiny::tags$p(
        class = "control-note",
        "Use the sliders below to adjust population parameters or sample sizes.
        An ANOVA will be run automatically whenever a slider is moved.
        The button at the bottom can also simulate new data using the same
        parameters and run an ANOVA."
      ),

      shiny::sliderInput(
        "mean1",
        shiny::HTML("&mu;<sub>1</sub>"),
        min = 100,
        max = 200,
        value = 150
      ),

      shiny::sliderInput(
        "mean2",
        shiny::HTML("&mu;<sub>2</sub>"),
        min = 100,
        max = 200,
        value = 160
      ),

      shiny::sliderInput(
        "mean3",
        shiny::HTML("&mu;<sub>3</sub>"),
        min = 100,
        max = 200,
        value = 150
      ),

      shiny::sliderInput(
        "sd",
        shiny::HTML("&sigma; (each group)"),
        min = 1,
        max = 35,
        value = 25
      ),

      shiny::sliderInput(
        "n",
        "n (per group)",
        min = 5,
        max = 100,
        value = 30
      ),

      shiny::br(),

      shiny::actionButton(
        "resimulate",
        "Simulate new data",
        width = "100%"
      )
    ),

    shiny::mainPanel(
      shiny::div(
        class = "boxplot-wrapper",
        shiny::plotOutput("boxplot")
      ),

      shiny::div(
        class = "app-subtitle",
        "Analysis of Variance"
      ),

      shiny::uiOutput("anova_decomposition"),
      shiny::uiOutput("p_value_section")
    )
  ),

  shiny::div(
    class = "footer-note",
    "Developed by ",
    shiny::tags$a(
      href = "https://vbaliga.github.io/",
      target = "_blank",
      rel = "noopener noreferrer",
      "Vikram Baliga"
    ),
    " at the University of British Columbia."
  )
)

server <- function(input, output, session) {
  p_value_visible <- shiny::reactiveVal(FALSE)

  data_reactive <- shiny::reactive({

    input$resimulate

    data.frame(
      value = c(
        stats::rnorm(input$n, mean = input$mean1, sd = input$sd),
        stats::rnorm(input$n, mean = input$mean2, sd = input$sd),
        stats::rnorm(input$n, mean = input$mean3, sd = input$sd)
      ),
      group = factor(
        rep(c("Group 1", "Group 2", "Group 3"), each = input$n),
        levels = c("Group 1", "Group 2", "Group 3")
      )
    )
  })

  shiny::observeEvent(input$show_p_value, {
    p_value_visible(TRUE)
  })

  shiny::observeEvent(
    base::list(input$mean1, input$mean2, input$mean3, input$sd, input$n),
    {
      p_value_visible(FALSE)
    },
    ignoreInit = TRUE
  )

  output$boxplot <- shiny::renderPlot({
    ggplot2::ggplot(
      data_reactive(),
      ggplot2::aes(x = group, y = value, color = group, fill = group)
    ) +
      ggplot2::geom_boxplot(alpha = 0.5) +
      ggplot2::geom_jitter(width = 0.2, alpha = 0.6, size = 2) +
      ggplot2::scale_color_manual(values = c("black", "black", "black")) +
      ggplot2::ylim(0, 300) +
      ggplot2::scale_fill_manual(values = group_colors) +
      ggplot2::labs(
        title = "Boxplot with individual data",
        x = NULL,
        y = "Value"
      ) +
      statsapps_plot_theme()
  })

  output$anova_decomposition <- shiny::renderUI({
    anova_result <- stats::aov(value ~ group, data = data_reactive())
    anova_table <- summary(anova_result)[[1]]

    SS_between <- anova_table["group", "Sum Sq"]
    df_between <- anova_table["group", "Df"]
    MS_between <- SS_between / df_between

    SS_within <- anova_table["Residuals", "Sum Sq"]
    df_within <- anova_table["Residuals", "Df"]
    MS_within <- SS_within / df_within

    SS_total <- SS_between + SS_within
    df_total <- df_between + df_within

    F_stat <- MS_between / MS_within

    shiny::HTML(
      paste0(
        "<table border='0' style='width:100%; text-align:left;'>",
        "<tr><th> </th><th>SS</th><th>df</th><th>MS</th></tr>",
        "<tr><td>Group</td><td>", round(SS_between, 3),
        "</td><td>", df_between,
        "</td><td>", round(MS_between, 3), "</td></tr>",
        "<tr><td>Error</td><td>", round(SS_within, 3),
        "</td><td>", df_within,
        "</td><td>", round(MS_within, 3), "</td></tr>",
        "</table><br>",
        "<b>SS<sub>total</sub> :</b> ", round(SS_total, 3),
        ", df<sub>total</sub>: ", df_total, "<br>",
        "<b>F :</b> ", round(F_stat, 3)
      )
    )
  })

  output$p_value_section <- shiny::renderUI({
    anova_result <- stats::aov(value ~ group, data = data_reactive())
    anova_table <- summary(anova_result)[[1]]

    p_value <- anova_table["group", "Pr(>F)"]

    p_value_text <- if (p_value < 0.0001) {
      "< 0.0001"
    } else {
      as.character(round(p_value, 4))
    }

    shiny::HTML(
      paste0(
        "<br>",
        "<b>P-value:</b> ",
        p_value_text
      )
    )
  })

}

shiny::shinyApp(ui = ui, server = server)

intercept_range <- c(-5, 12)
slope_range <- c(-2, 4)

intercept_step <- 0.25
slope_step <- 0.25

default_intercept <- intercept_range[1]
default_slope <- slope_range[1]

slider_values <- function(range, step) {
  round(seq(range[1], range[2], by = step), 10)
}

format_number <- function(x, digits = 2) {
  formatC(x, format = "f", digits = digits)
}

format_signed_slope <- function(slope, variable_name) {
  sign_text <- if (slope >= 0) {
    " + "
  } else {
    " - "
  }

  paste0(
    sign_text,
    format_number(abs(slope), digits = 2),
    " ",
    variable_name
  )
}

make_initial_seed <- function() {
  seed <- as.integer((as.numeric(Sys.time()) * 1000) %% 1000000)

  if (!is.finite(seed) || seed < 1) {
    seed <- 202607
  }

  seed
}

relationship_specs <- list(
  raw_linear = list(
    solution_log_x = FALSE,
    solution_log_y = FALSE,
    relationship_label = "Y and X",
    x_label = "X",
    y_label = "Y",
    intercept_values = seq(8, 12, by = intercept_step),
    slope_values = c(-1.25, -1, -0.75, -0.5, 0.5, 0.75, 1, 1.25),
    residual_sd = 0.6
  ),
  log_x = list(
    solution_log_x = TRUE,
    solution_log_y = FALSE,
    relationship_label = "Y and log(X)",
    x_label = "log(X)",
    y_label = "Y",
    intercept_values = seq(8, 12, by = intercept_step),
    slope_values = c(-2, -1.5, -1, -0.75, 0.75, 1, 1.5, 2),
    residual_sd = 0.6
  ),
  log_y = list(
    solution_log_x = FALSE,
    solution_log_y = TRUE,
    relationship_label = "log(Y) and X",
    x_label = "X",
    y_label = "log(Y)",
    intercept_values = seq(1.25, 2.5, by = intercept_step),
    slope_values = c(-0.5, -0.25, 0.25, 0.5),
    residual_sd = 0.25
  ),
  log_x_log_y = list(
    solution_log_x = TRUE,
    solution_log_y = TRUE,
    relationship_label = "log(Y) and log(X)",
    x_label = "log(X)",
    y_label = "log(Y)",
    intercept_values = seq(1.25, 2.5, by = intercept_step),
    slope_values = c(-1, -0.75, -0.5, 0.5, 0.75, 1),
    residual_sd = 0.25
  )
)

preserve_random_seed <- function() {
  if (exists(".Random.seed", envir = .GlobalEnv, inherits = FALSE)) {
    list(
      exists = TRUE,
      value = get(".Random.seed", envir = .GlobalEnv, inherits = FALSE)
    )
  } else {
    list(
      exists = FALSE,
      value = NULL
    )
  }
}

restore_random_seed <- function(saved_seed) {
  if (isTRUE(saved_seed$exists)) {
    assign(".Random.seed", saved_seed$value, envir = .GlobalEnv)
  } else if (exists(".Random.seed", envir = .GlobalEnv, inherits = FALSE)) {
    rm(".Random.seed", envir = .GlobalEnv)
  }

  invisible(NULL)
}

generate_data_from_model <- function(
    data_seed,
    intercept,
    slope,
    residual_sd,
    log_x_model,
    log_y_model
) {
  saved_seed <- preserve_random_seed()
  on.exit(restore_random_seed(saved_seed), add = TRUE)

  set.seed(data_seed)

  n <- 100

  x_log_true <- stats::runif(
    n,
    min = log(0.4),
    max = log(4)
  )

  x <- exp(x_log_true)

  x_model <- if (isTRUE(log_x_model)) {
    log(x)
  } else {
    x
  }

  raw_error <- stats::rnorm(
    n,
    mean = 0,
    sd = residual_sd
  )

  random_error <- stats::residuals(
    stats::lm(raw_error ~ x_model)
  )

  random_error <- random_error / stats::sd(random_error) * residual_sd

  y_model <- intercept + slope * x_model + random_error

  y <- if (isTRUE(log_y_model)) {
    exp(y_model)
  } else {
    y_model
  }

  if (!all(is.finite(y)) || !all(y > 0)) {
    stop(
      "Could not simulate a valid positive Y dataset.",
      call. = FALSE
    )
  }

  data.frame(
    x = x,
    y = y
  )
}

simulate_linear_reg_data <- function(seed) {
  saved_seed <- preserve_random_seed()
  on.exit(restore_random_seed(saved_seed), add = TRUE)

  set.seed(seed)

  relationship_id <- sample(names(relationship_specs), size = 1)
  spec <- relationship_specs[[relationship_id]]

  intercept <- sample(spec$intercept_values, size = 1)
  slope <- sample(spec$slope_values, size = 1)

  max_attempts <- 100

  for (attempt in seq_len(max_attempts)) {
    candidate_data_seed <- sample.int(1000000, size = 1)

    data <- tryCatch(
      generate_data_from_model(
        data_seed = candidate_data_seed,
        intercept = intercept,
        slope = slope,
        residual_sd = spec$residual_sd,
        log_x_model = spec$solution_log_x,
        log_y_model = spec$solution_log_y
      ),
      error = function(e) NULL
    )

    if (!is.null(data)) {
      data_seed <- candidate_data_seed
      break
    }

    if (attempt == max_attempts) {
      stop(
        "Could not simulate a valid positive Y dataset.",
        call. = FALSE
      )
    }
  }

  list(
    data = data,
    seed = seed,
    data_seed = data_seed,
    relationship_id = relationship_id,
    relationship_label = spec$relationship_label,
    solution_log_x = spec$solution_log_x,
    solution_log_y = spec$solution_log_y,
    solution_intercept = intercept,
    solution_slope = slope,
    residual_sd = spec$residual_sd,
    x_label = spec$x_label,
    y_label = spec$y_label
  )
}

calculate_ssr <- function(data, intercept, slope, log_x, log_y) {
  x_display <- if (isTRUE(log_x)) {
    log(data$x)
  } else {
    data$x
  }

  y_display <- if (isTRUE(log_y)) {
    log(data$y)
  } else {
    data$y
  }

  fitted_display <- intercept + slope * x_display
  residual <- y_display - fitted_display

  sum(residual^2)
}

make_feedback_box <- function(type, label, text) {
  shiny::div(
    class = paste("feedback-box", paste0("feedback-", type)),
    shiny::span(class = "feedback-label", label),
    " ",
    text
  )
}

solution_formula_text <- function(simulation, include_error = FALSE) {
  lhs <- if (isTRUE(simulation$solution_log_y)) {
    "log(Y)"
  } else {
    "Y"
  }

  rhs <- if (isTRUE(simulation$solution_log_x)) {
    "log(X)"
  } else {
    "X"
  }

  paste0(
    lhs,
    " = ",
    format_number(simulation$solution_intercept, digits = 2),
    format_signed_slope(simulation$solution_slope, rhs),
    if (isTRUE(include_error)) {
      " + random error"
    } else {
      ""
    }
  )
}

simulation_code_text <- function(simulation) {
  x_model_line <- if (isTRUE(simulation$solution_log_x)) {
    "x_model <- log(x)"
  } else {
    "x_model <- x"
  }

  y_line <- if (isTRUE(simulation$solution_log_y)) {
    "y <- exp(y_model)"
  } else {
    "y <- y_model"
  }

  response_text <- if (isTRUE(simulation$solution_log_y)) {
    "log(y)"
  } else {
    "y"
  }

  predictor_text <- if (isTRUE(simulation$solution_log_x)) {
    "log(x)"
  } else {
    "x"
  }

  paste0(
    "set.seed(", simulation$data_seed, ")\n\n",
    "n <- 100\n",
    "intercept <- ",
    format_number(simulation$solution_intercept, digits = 2),
    "\n",
    "slope <- ",
    format_number(simulation$solution_slope, digits = 2),
    "\n",
    "residual_sd <- ",
    format_number(simulation$residual_sd, digits = 2),
    "\n\n",
    "x_log_true <- runif(n, min = log(0.4), max = log(4))\n",
    "x <- exp(x_log_true)\n\n",
    x_model_line, "\n\n",
    "raw_error <- rnorm(n, mean = 0, sd = residual_sd)\n\n",
    "random_error <- residuals(lm(raw_error ~ x_model))\n",
    "random_error <- random_error / sd(random_error) * residual_sd\n\n",
    "y_model <- intercept + slope * x_model + random_error\n",
    y_line, "\n\n",
    "linreg_data <- data.frame(x = x, y = y)\n\n",
    "summary(lm(",
    response_text,
    " ~ ",
    predictor_text,
    ", data = linreg_data))"
  )
}

statsapps_shared_file <- function(...) {
  installed_file <- system.file("app_shared", ..., package = "statsapps")

  if (nzchar(installed_file)) {
    return(installed_file)
  }

  file.path("..", "..", "app_shared", ...)
}

source(statsapps_shared_file("app_settings.R"), local = TRUE)

ui <- shiny::fluidPage(
  shiny::tags$head(
    shiny::includeCSS(statsapps_shared_file("statsapps.css")),
    shiny::tags$style(shiny::HTML("
      .plot-grid {
        display: grid;
        grid-template-columns: minmax(0, 1fr) minmax(0, 1fr);
        column-gap: 34px;
        row-gap: 28px;
        align-items: start;
      }

      .plot-cell {
        min-width: 0;
      }

      .plot-cell .app-subtitle {
        margin-top: 18px;
      }

      @media (max-width: 1100px) {
        .plot-grid {
          grid-template-columns: 1fr;
        }
      }

      .ssr-cell {
        display: flex;
        flex-direction: column;
        align-self: end;
      }

      .plot-grid > .ssr-cell {
        align-self: end;
      }

      .ssr-plot-wrap {
        margin-top: 8px;
        margin-bottom: 8px;
      }

      .button-row {
        display: grid;
        grid-template-columns: 1fr 1fr 1.35fr;
        gap: 6px;
        margin-top: 18px;
        margin-bottom: 12px;
      }

      .button-row .btn {
        width: 100%;
        white-space: normal;
      }

      .residual-mean-note {
        margin-bottom: 8px;
      }

      .feedback-box {
        border-left: 4px solid #cccccc;
        border-radius: 4px;
        padding: 8px 10px;
        margin-top: 8px;
        margin-bottom: 12px;
        font-size: 15px;
        line-height: 1.35;
      }

      .feedback-good {
        border-left-color: #2E7D32;
        background-color: #F1F8F3;
      }

      .feedback-neutral {
        border-left-color: #A36A00;
        background-color: #FFF8E8;
      }

      .feedback-warn {
        border-left-color: #B3261E;
        background-color: #FFF2F0;
      }

      .feedback-label {
        font-weight: 700;
      }

      .ssr-title sub {
        font-size: 60%;
        vertical-align: sub;
      }

      .ssr-formula {
        font-family: Georgia, 'Times New Roman', serif;
        font-size: 21px;
        line-height: 1.4;
        margin-top: 6px;
        margin-bottom: 12px;
      }

      .ssr-formula sub {
        font-size: 65%;
      }

      .ssr-formula sup {
        font-size: 70%;
      }

      .solution-box {
        background-color: #ffffff;
        border: 1px solid #dddddd;
        border-radius: 4px;
        padding: 12px;
        margin-top: 18px;
      }

      .solution-box h4 {
        margin-top: 0;
        color: #315f96;
        font-weight: 400;
      }

      .solution-box pre {
        font-size: 12px;
        white-space: pre-wrap;
        word-break: normal;
      }

      .simulation-box {
        background-color: #f7f7f7;
      }

      .simulation-box p {
        margin-bottom: 8px;
      }
    "))
  ),

  shiny::titlePanel(
    shiny::div(
      class = "app-title",
      "Fitting a linear regression"
    )
  ),

  shiny::sidebarLayout(
    shiny::sidebarPanel(
      width = 4,

      shiny::tags$p(
        class = "control-note",
        "The scatterplot shows data and a linear model that
        has parameters based on the sliders below. Find values for
        the intercept and slope that minimize the residual error. Consider
        whether it would help to log transform either variable (or both).
        Hit 'Show solution' when you think you have found the best values for
        parameters."
      ),

      shiny::sliderInput(
        "intercept",
        "Intercept",
        min = intercept_range[1],
        max = intercept_range[2],
        value = default_intercept,
        step = intercept_step
      ),

      shiny::sliderInput(
        "slope",
        "Slope",
        min = slope_range[1],
        max = slope_range[2],
        value = default_slope,
        step = slope_step
      ),

      shiny::checkboxInput(
        "log_x",
        "Use log(X)",
        value = FALSE
      ),

      shiny::checkboxInput(
        "log_y",
        "Use log(Y)",
        value = FALSE
      ),

      shiny::div(
        class = "button-row",
        shiny::actionButton("reset", "Reset"),
        shiny::actionButton("solution", "Show solution"),
        shiny::actionButton("simulate_data", "Simulate new data")
      ),

      shiny::uiOutput("solution_box")
    ),

    shiny::mainPanel(
      width = 8,

      shiny::div(
        class = "plot-grid",

        shiny::div(
          class = "plot-cell",
          shiny::div(
            class = "app-subtitle",
            "Data and fitted linear model"
          ),
          shiny::plotOutput("regression_plot", height = "390px"),
          shiny::tags$p(
            class = "plot-note",
            "The black line is your current linear model.
            Red vertical lines show residuals. The other 3 plots show further
            info on how well the linear model fits the data."
          )
        ),

        shiny::div(
          class = "plot-cell ssr-cell",
          shiny::div(
            class = "app-subtitle ssr-title",
            "Sum of squared residuals"
          ),
          shiny::div(
            class = "ssr-formula",
            shiny::HTML(
              "SS<sub>residual</sub> = &sum;<sub>i</sub> (Y<sub>i</sub> &minus; &#374;<sub>i</sub>)<sup>2</sup>"
            )
          ),
          shiny::div(
            class = "ssr-plot-wrap",
            shiny::plotOutput("ssr_plot", height = "230px")
          ),
          shiny::uiOutput("ssr_feedback")
        ),

        shiny::div(
          class = "plot-cell",
          shiny::div(
            class = "app-subtitle",
            "Residual plot"
          ),
          shiny::plotOutput("residual_plot", height = "300px"),
          shiny::uiOutput("residual_pattern_feedback")
        ),

        shiny::div(
          class = "plot-cell",
          shiny::div(
            class = "app-subtitle",
            "Distribution of residuals"
          ),
          shiny::plotOutput("residual_distribution", height = "300px"),
          shiny::uiOutput("residual_mean_feedback")
        )
      )
    )
  ),

  shiny::div(
    class = "footer-note",
    "Developed by ",
    shiny::tags$a(
      href = "https://vbaliga.github.io/",
      target = "_blank",
      rel = "noopener noreferrer",
      "Vikram Baliga"
    ),
    " at the University of British Columbia."
  )
)

server <- function(input, output, session) {
  solution_visible <- shiny::reactiveVal(FALSE)
  data_seed <- shiny::reactiveVal(make_initial_seed())

  current_simulation <- shiny::reactive({
    simulate_linear_reg_data(seed = data_seed())
  })

  current_data <- shiny::reactive({
    current_simulation()$data
  })

  reset_controls <- function() {
    shiny::updateCheckboxInput(
      session = session,
      inputId = "log_x",
      value = FALSE
    )

    shiny::updateCheckboxInput(
      session = session,
      inputId = "log_y",
      value = FALSE
    )

    shiny::updateSliderInput(
      session = session,
      inputId = "intercept",
      min = intercept_range[1],
      max = intercept_range[2],
      value = default_intercept,
      step = intercept_step
    )

    shiny::updateSliderInput(
      session = session,
      inputId = "slope",
      min = slope_range[1],
      max = slope_range[2],
      value = default_slope,
      step = slope_step
    )
  }

  displayed_data <- shiny::reactive({
    data <- current_data()

    data$x_display <- if (isTRUE(input$log_x)) {
      log(data$x)
    } else {
      data$x
    }

    data$y_display <- if (isTRUE(input$log_y)) {
      log(data$y)
    } else {
      data$y
    }

    data$fitted_display <- input$intercept + input$slope * data$x_display
    data$residual <- data$y_display - data$fitted_display

    data
  })

  output$solution_summary <- shiny::renderPrint({
    simulation <- current_simulation()
    data <- simulation$data

    model_data <- data.frame(
      Y = data$y,
      log_Y = log(data$y),
      X = data$x,
      log_X = log(data$x)
    )

    response_name <- if (isTRUE(simulation$solution_log_y)) {
      "log_Y"
    } else {
      "Y"
    }

    predictor_name <- if (isTRUE(simulation$solution_log_x)) {
      "log_X"
    } else {
      "X"
    }

    model_formula <- stats::as.formula(
      paste(response_name, "~", predictor_name)
    )

    summary(stats::lm(model_formula, data = model_data))
  })

  output$solution_box <- shiny::renderUI({
    if (!solution_visible()) {
      return(NULL)
    }

    simulation <- current_simulation()

    shiny::tagList(
      shiny::div(
        class = "solution-box",
        shiny::tags$h4("Solution"),
        shiny::tags$p(
          paste0(
            "These data show a linear relationship between ",
            simulation$relationship_label,
            "."
          )
        ),
        shiny::tags$p(
          shiny::HTML(
            paste0(
              "The best-fit line is: <strong>",
              solution_formula_text(simulation),
              "</strong>."
            )
          )
        ),
        shiny::verbatimTextOutput("solution_summary")
      ),

      shiny::div(
        class = "solution-box simulation-box",
        shiny::tags$h4("R code used to simulate these data"),
        shiny::tags$pre(
          simulation_code_text(simulation)
        )
      )
    )
  })

  shiny::observeEvent(input$solution, {
    simulation <- current_simulation()

    solution_visible(TRUE)

    shiny::updateCheckboxInput(
      session = session,
      inputId = "log_x",
      value = simulation$solution_log_x
    )

    shiny::updateCheckboxInput(
      session = session,
      inputId = "log_y",
      value = simulation$solution_log_y
    )

    shiny::updateSliderInput(
      session = session,
      inputId = "intercept",
      value = simulation$solution_intercept
    )

    shiny::updateSliderInput(
      session = session,
      inputId = "slope",
      value = simulation$solution_slope
    )
  })

  shiny::observeEvent(input$reset, {
    solution_visible(FALSE)
    reset_controls()
  })

  shiny::observeEvent(input$simulate_data, {
    solution_visible(FALSE)
    data_seed(data_seed() + 1L)
    reset_controls()
  })

  current_ssr <- shiny::reactive({
    sum(displayed_data()$residual^2)
  })

  ssr_grid <- shiny::reactive({
    intercept_values <- slider_values(intercept_range, intercept_step)
    slope_values <- slider_values(slope_range, slope_step)

    combinations <- expand.grid(
      intercept = intercept_values,
      slope = slope_values,
      KEEP.OUT.ATTRS = FALSE
    )

    combinations$ssr <- mapply(
      FUN = calculate_ssr,
      intercept = combinations$intercept,
      slope = combinations$slope,
      MoreArgs = list(
        data = current_data(),
        log_x = input$log_x,
        log_y = input$log_y
      )
    )

    combinations
  })

  target_ssr <- shiny::reactive({
    min(ssr_grid()$ssr)
  })

  ssr_relative_gap <- shiny::reactive({
    gap <- max(current_ssr() - target_ssr(), 0)

    if (target_ssr() <= .Machine$double.eps) {
      return(gap)
    }

    gap / target_ssr()
  })

  residual_mean_value <- shiny::reactive({
    mean(displayed_data()$residual)
  })

  residual_mean_scaled <- shiny::reactive({
    data <- displayed_data()
    denominator <- stats::sd(data$y_display)

    if (!is.finite(denominator) || denominator <= .Machine$double.eps) {
      return(abs(residual_mean_value()))
    }

    abs(residual_mean_value()) / denominator
  })

  residual_x_correlation <- shiny::reactive({
    data <- displayed_data()

    if (
      stats::sd(data$x_display) <= .Machine$double.eps ||
      stats::sd(data$residual) <= .Machine$double.eps
    ) {
      return(0)
    }

    stats::cor(data$x_display, data$residual)
  })

  ssr_axis_max <- shiny::reactive({
    max_ssr <- max(
      current_ssr(),
      target_ssr()
    )

    if (!is.finite(max_ssr) || max_ssr <= 0) {
      return(1)
    }

    max(pretty(c(0, max_ssr * 1.15), n = 5))
  })

  axis_labels <- shiny::reactive({
    list(
      x = if (isTRUE(input$log_x)) {
        "log(X)"
      } else {
        "X"
      },
      y = if (isTRUE(input$log_y)) {
        "log(Y)"
      } else {
        "Y"
      }
    )
  })

  line_data <- shiny::reactive({
    data <- displayed_data()

    x_values <- range(data$x_display)

    data.frame(
      x_display = x_values,
      fitted_display = input$intercept + input$slope * x_values
    )
  })

  output$regression_plot <- shiny::renderPlot({
    labels <- axis_labels()

    ggplot2::ggplot(
      displayed_data(),
      ggplot2::aes(x = x_display, y = y_display)
    ) +
      ggplot2::geom_segment(
        ggplot2::aes(
          xend = x_display,
          yend = fitted_display
        ),
        color = "#c92514",
        linewidth = 0.3,
        alpha = 0.75
      ) +
      ggplot2::geom_point(
        color = "#222222",
        size = 2.3,
        alpha = 0.85
      ) +
      ggplot2::geom_line(
        data = line_data(),
        ggplot2::aes(x = x_display, y = fitted_display),
        color = "#222222",
        linewidth = 1.1
      ) +
      ggplot2::labs(
        x = labels$x,
        y = labels$y
      ) +
      statsapps_plot_theme() +
      ggplot2::theme(
        axis.title = ggplot2::element_text(face = "bold"),
        axis.text = ggplot2::element_text(color = "#222222")
      )
  })

  output$ssr_plot <- shiny::renderPlot({
    current_val <- current_ssr()
    target_val <- target_ssr()
    axis_max <- ssr_axis_max()

    plot_data <- data.frame(
      x = c(0.08, 0.08),
      ssr = c(current_val, target_val),
      marker = c("Current", "Target"),
      label = c("Current attempt", "Minimum")
    )

    ggplot2::ggplot(plot_data, ggplot2::aes(x = x, y = ssr)) +
      ggplot2::geom_point(
        data = subset(plot_data, marker == "Target"),
        shape = 1,
        size = 6,
        stroke = 2,
        color = "#222222"
      ) +
      ggplot2::geom_point(
        data = subset(plot_data, marker == "Current"),
        shape = 4,
        size = 6,
        stroke = 2,
        color = "#c92514"
      ) +
      ggplot2::geom_text(
        ggplot2::aes(
          x = 0.18,
          label = label,
          color = marker
        ),
        hjust = 0,
        size = 4.5,
        show.legend = FALSE
      ) +
      ggplot2::scale_color_manual(
        values = c(
          "Current" = "#c92514",
          "Target" = "#222222"
        )
      ) +
      ggplot2::scale_x_continuous(
        limits = c(0, 1),
        breaks = NULL,
        expand = c(0, 0)
      ) +
      ggplot2::scale_y_continuous(
        limits = c(-0.05 * axis_max, axis_max),
        breaks = pretty(c(0, axis_max), n = 5),
        expand = ggplot2::expansion(mult = c(0, 0.06))
      ) +
      ggplot2::labs(
        x = NULL,
        y = expression(SS[residual])
      ) +
      ggplot2::coord_cartesian(clip = "off") +
      statsapps_plot_theme() +
      ggplot2::theme(
        axis.line.x = ggplot2::element_blank(),
        axis.ticks.x = ggplot2::element_blank(),
        axis.text.x = ggplot2::element_blank(),
        axis.title.x = ggplot2::element_blank(),
        axis.title.y = ggplot2::element_text(
          angle = 90,
          face = "bold",
          margin = ggplot2::margin(r = 10)
        ),
        axis.text.y = ggplot2::element_text(color = "#222222"),
        plot.margin = ggplot2::margin(12, 70, 24, 20)
      )
  })

  output$ssr_feedback <- shiny::renderUI({
    gap <- ssr_relative_gap()

    if (gap <= 0.001) {
      make_feedback_box(
        type = "good",
        label = "Excellent:",
        text = "SS residual is minimized for the variables as currently
        plotted."
      )
    } else if (gap <= 0.05) {
      make_feedback_box(
        type = "good",
        label = "Very close:",
        text = "The SS residual is very close to the minimum possible value."
      )
    } else if (gap <= 0.15) {
      make_feedback_box(
        type = "neutral",
        label = "Getting closer:",
        text = "The SS residual is approaching its minimum possible value.
        Try reducing it further."
      )
    } else {
      make_feedback_box(
        type = "warn",
        label = "Keep adjusting:",
        text = "The SS residual is far from its minimum possible value.
        Try to get the X close as possible to the open circle (its minimal value
        for these data)."
      )
    }
  })

  output$residual_plot <- shiny::renderPlot({
    labels <- axis_labels()

    ggplot2::ggplot(
      displayed_data(),
      ggplot2::aes(x = x_display, y = residual)
    ) +
      ggplot2::geom_hline(
        yintercept = 0,
        color = "#555555",
        linewidth = 0.8
      ) +
      ggplot2::geom_point(
        color = "#c92514",
        size = 2.3,
        alpha = 0.85
      ) +
      ggplot2::labs(
        x = labels$x,
        y = "Residual"
      ) +
      statsapps_plot_theme() +
      ggplot2::theme(
        axis.title = ggplot2::element_text(face = "bold"),
        axis.text = ggplot2::element_text(color = "#222222")
      )
  })

  output$residual_pattern_feedback <- shiny::renderUI({
    residual_correlation <- residual_x_correlation()
    abs_correlation <- abs(residual_correlation)

    if (abs_correlation <= 0.05) {
      make_feedback_box(
        type = "good",
        label = "Good sign:",
        text = "The residuals show little correlation with the explanatory
        variable. Ensure that the spread of points above and below the line is
        similar across the range of the x-axis."
      )
    } else if (abs_correlation <= 0.20) {
      make_feedback_box(
        type = "neutral",
        label = "Possible pattern:",
        text = "The residuals show a small remaining trend with X."
      )
    } else if (residual_correlation > 0) {
      make_feedback_box(
        type = "warn",
        label = "Pattern detected:",
        text = "Residuals tend to increase with X."
      )
    } else {
      make_feedback_box(
        type = "warn",
        label = "Pattern detected:",
        text = "Residuals tend to decrease with X."
      )
    }
  })

  output$residual_mean_feedback <- shiny::renderUI({
    residual_mean <- residual_mean_value()
    scaled_mean <- residual_mean_scaled()

    if (scaled_mean <= 0.01) {
      make_feedback_box(
        type = "good",
        label = "Excellent:",
        text = "The mean residual is essentially 0."
      )
    } else if (scaled_mean <= 0.05) {
      make_feedback_box(
        type = "neutral",
        label = "Close:",
        text = "The mean residual is fairly close to 0."
      )
    } else if (residual_mean > 0) {
      make_feedback_box(
        type = "warn",
        label = "Check the fit:",
        text = "The mean residual is positive, so the line is underpredicting
        on average."
      )
    } else {
      make_feedback_box(
        type = "warn",
        label = "Check the fit:",
        text = "The mean residual is negative, so the line is overpredicting
        on average."
      )
    }
  })

  output$residual_distribution <- shiny::renderPlot({
    data <- displayed_data()
    residual_mean <- mean(data$residual)

    hist_info <- hist(
      data$residual,
      breaks = 18,
      plot = FALSE
    )

    y_top <- max(hist_info$density, na.rm = TRUE)
    x_range <- range(data$residual, na.rm = TRUE)
    x_nudge <- 0.03 * diff(x_range)

    if (residual_mean <= mean(x_range)) {
      label_x <- residual_mean + x_nudge
      hjust_value <- 0
    } else {
      label_x <- residual_mean - x_nudge
      hjust_value <- 1
    }

    ggplot2::ggplot(
      data,
      ggplot2::aes(x = residual)
    ) +
      ggplot2::geom_histogram(
        ggplot2::aes(y = ggplot2::after_stat(density)),
        bins = 18,
        fill = "#c92514",
        color = "#222222",
        alpha = 0.85
      ) +
      ggplot2::geom_vline(
        xintercept = residual_mean,
        color = "#222222",
        linewidth = 1.1,
        linetype = "dashed"
      ) +
      ggplot2::annotate(
        "text",
        x = label_x,
        y = y_top * 0.96,
        label = paste0(
          "Mean: ",
          formatC(residual_mean, format = "f", digits = 3)
        ),
        hjust = hjust_value,
        vjust = 1,
        size = 5
      ) +
      ggplot2::labs(
        x = "Residual",
        y = "Density"
      ) +
      ggplot2::coord_cartesian(clip = "off") +
      statsapps_plot_theme() +
      ggplot2::theme(
        axis.title = ggplot2::element_text(face = "bold"),
        axis.text = ggplot2::element_text(color = "#222222"),
        plot.margin = ggplot2::margin(10, 20, 10, 10)
      )
  })
}

shiny::shinyApp(ui = ui, server = server)

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_sums_squares_app.R
\name{run_sums_squares_app}
\alias{run_sums_squares_app}
\title{Launch the sums of squares app}
\usage{
run_sums_squares_app(...)
}
\arguments{
\item{...}{Optional arguments passed to \code{\link[shiny:runApp]{shiny::runApp()}}. By default,
statsapps opens apps in the system default web browser using
\code{launch.browser = TRUE}. Use \code{launch.browser = FALSE} to disable this
behavior.}
}
\value{
\code{run_sums_squares_app()} opens the Shiny app locally.
}
\description{
Opens an interactive Shiny app for exploring how total variation can be
partitioned into group-level and within-group components in one-way ANOVA.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
run_sums_squares_app()
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/run_permutation_app.R
\name{run_permutation_app}
\alias{run_permutation_app}
\title{Launch the permutation test app}
\usage{
run_permutation_app(...)
}
\arguments{
\item{...}{Optional arguments passed to \code{\link[shiny:runApp]{shiny::runApp()}}. By default,
statsapps opens apps in the system default web browser using
\code{launch.browser = TRUE}. Use \code{launch.browser = FALSE} to disable this
behavior.}
}
\value{
\code{run_permutation_app()} opens the Shiny app locally.
}
\description{
\code{run_permutation_app()} opens an interactive Shiny app that demonstrates how
repeated random reassignment of observations can be used to build a null
distribution for a two-sample permutation test.
}
\details{
The app uses data on time to mating in female sagebrush crickets from
Johnson et al. (1999), as presented in \emph{The Analysis of Biological Data} by
Whitlock and Schluter.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
run_permutation_app()
\dontshow{\}) # examplesIf}
}
\references{
Johnson, J. C., T. M. Ivy, and S. K. Sakaluk. 1999. Female remating
propensity contingent on sexual cannibalism in sagebrush crickets,
\emph{Cyphoderris strepitans}: a mechanism of cryptic female choice.
\emph{Behavioral Ecology} 10: 227-233.

Whitlock, M. C., and D. Schluter. 2020. \emph{The Analysis of Biological Data}.
3rd ed. W. H. Freeman and Company.
}
